'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' ThiefAware - A simple application for webcam survellance
'
VERSION	"1.00"
'CONSOLE
'
	IMPORT	"xst_s"   		' standard library	: required by most programs
	IMPORT  "xsx_s"				' extended std library
	IMPORT	"xma_s"
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT	"comdlg32"  ' comdlg32.dll	    : common dialog library
'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT	"xcm"				' complex math library
'	IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'	IMPORT  "shell32"   ' shell32.dll
	IMPORT	"advapi32"	' registry functions
	IMPORT	"vfw32"			' video capture
	IMPORT	"ThiefAwareRes.dec"	' constants for dialogs
'
'declare control id constants
$$MAIN_STB						=	10000
$$MAIN_TABS						= 10001
$$MAIN_TIMER					= 10002
$$RECORD_SNAP					= 10101
$$RECORD_CONFIG				= 10102
$$RECORD_CAPTURE			= 10103
$$REVIEW_LIST					= 10201
$$REVIEW_VIEW					= 10202
$$REVIEW_BT_SAVEPIC		= 10208
'$$REVIEW_BT_SAVEMOV		= 10209
$$REVIEW_BT_DELETE		= 10210
$$LIST_SB							= 20001
$$LIST_FIRSTBT				= 20002
$$VIEW_BT_PREV				= 30001
$$VIEW_BT_PLAY				= 30002
$$VIEW_BT_NEXT				= 30003
$$VIEW_TRKBR_SPEED		= 30004
$$VIEW_TRKBR_POS			= 30005
$$VIEW_TIMER					= 30006
$$VIEW_BT_REWIND			= 30007
$$VIEW_BT_FF					= 30008

$$PAGE_RECORD	=	0
$$PAGE_REVIEW	=	1

'monitering modes
$$MONMODE_TIMELAPSE		= 0
$$MONMODE_MODETECT		= 1

'status
$$STATUS_WAITING		= 0
$$STATUS_IDLING			= 1
$$STATUS_MONITERING	= 2
$$STATUS_MOFOUND		= 3
$$STATUS_RECORDING	= 4
$$STATUS_REVIEW			= 5
$$STATUS_STOPPED		= 6
$$STATUS_PLAYING		= 7

'other constants
$$IDLEFRAMEINT	= 40

'custom messages
'for view window
$$VWNM_SAVEPIC	=	0x400
$$VWNM_SAVEMOV	=	0x401
$$VWNM_LOAD			= 0x402	'wParam:iFile to load
$$VWNM_UNLOAD		= 0x403
'for the thumbnail list
$$THLM_ADDCLIP		= 0x403	'wParam:hBmp of image, lParam:iFile of image
$$THLM_BUTTONSUP	= 0x404
$$THLM_SELECTFILE	= 0x405	'wParam:iFile to select
$$THLM_DELCLIP		= 0x406	'returns $$TRUE on success or $$FALSE if no clip selected
$$THLN_CLIPSEL		= 0x407	'wParam = iFile of selected clip

'this keeps info on the GUI
TYPE GUIINFO
	XLONG	.hStatusBar
	XLONG	.hMainToolTips
	XLONG	.hTabs
	XLONG	.currentTab
	'for the record page
	XLONG	.hCap
	XLONG	.capHeight
	XLONG	.capWidth
	XLONG	.hSnapButton
	XLONG	.hConfigButton
	'for the review page
	XLONG	.hList
	XLONG	.hView
	XLONG	.viewWidth
	XLONG	.viewHeight
	XLONG	.hSavePicButton
'	XLONG	.hSaveMovieButton
	XLONG	.hDeleteButton
	'for the list pane
	XLONG	.hScroll
	XLONG	.hToolTips
	XLONG	.currentClip	'index of the currently selected clip
	'for the view pane
	XLONG	.hDDdc
	XLONG	.hViewToolTips
	XLONG	.hPosTracker
	XLONG	.hPrevButton
	XLONG	.hPlayButton
	XLONG	.hNextButton
	XLONG	.hRewind
	XLONG	.hFastFoward
	XLONG	.hSpeedTracker
END TYPE

TYPE THUMBINFO
	XLONG	.active				'$$TRUE if button is pressed
	XLONG	.hButton			'handle to button
	XLONG	.hBMP					'handle to the bitmap
	XLONG	.iFile				'index to file in the file list
END TYPE

TYPE FILENAME
	STRING*15	.name		'name of a file
	SBYTE			.recordUsed	'0 if the record is free
	FILETIME	.fileTime
	USHORT		.width
	USHORT		.height
	XLONG			.frameCount	'the number of frames in the sequence
	XLONG			.frameInt		'the number of milliseconds between each frame
	GIANT			.size				'the number of bytes in this file
END TYPE

TYPE FILEINDEXHEADER
	STRING*4	.magic
	ULONG			.version
	XLONG			.recordCount
END TYPE

'Settings for motion detection
TYPE MOTIONSETTINGS
	XLONG	.sampleInt	'interval in ms
	XLONG	.blockSize	'the block size
	ULONG	.tolerance	'AND with XOR to get crop insignificant bits off diff
	ULONG	.toCapture	'the number of frames we still need to record, when at 1, start the motion detector again
	ULONG	.toCapCount	'the number of frames to catch each time motion is detected
END TYPE
'state information
'this keeps the app's internal state
TYPE APPSTATE
	XLONG	.devID		'id of the device we are using
	ULONG	.timerStart	'timer start	00HHMMSS
	ULONG	.timerEnd		'timer end		00HHMMSS
	XLONG	.noUseTimer		'$$TRUE if we shouldn't use the timer
	XLONG	.moniterMode	'a $$MONMODE constant
	XLONG	.frameInt		'interval between frames in ms
	XLONG	.showRecIcon
	XLONG	.dateStamp
	XLONG	.useTimer
	XLONG	.spaceLimit
	GIANT	.GSpaceLimit
	GIANT	.usedSpace
	XLONG	.hWriteThread
	XLONG	.hReadThread
	XLONG	.pWriteCommBlock
	XLONG	.pReadCommBlock
	MOTIONSETTINGS	.motionSettings	'settings for motion detection
	XLONG	.hRawFont
	XLONG	.status
	XLONG	.fileNum			'file number for the file we're recording to, in player mode, it is the file we're reading from
	XLONG	.fileId				'id in the fileIndex of the file we're recording, in player mode, it is the file we're playing
	XLONG	.currentFrame	'0 based
	XLONG	.totalFrames	'used by the player
	XLONG	.cbFrame			'the size of a frame
	XLONG	.thumbWidth
END TYPE

TYPE READINFO
	XLONG	.inUse
	XLONG	.fileNumber
	XLONG	.totalFrames
	XLONG	.frameSize
	XLONG	.firstFrame
	XLONG	.framesPerBuffer
	XLONG	.localBuffer		'address of the buffer
	XLONG	.halfBuffer		'the offset at which the buffer must be swapped
	XLONG	.ourBuffer			'the offset to the buffer we're using
END TYPE

'template functions
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION RegisterWinClass (className$, addrWndProc, icon, menu)
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (className$, titleBar$, style, x, y, w, h, exStyle)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION CleanUp          ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)
'GUI functions
DECLARE FUNCTION MainOnCreate			(hWnd)
DECLARE FUNCTION showHidePage			(page, show)
DECLARE FUNCTION sizeCapWin 			()
DECLARE FUNCTION updatePositions 	()
DECLARE FUNCTION sizeMainControls (hWnd, w, h)
DECLARE FUNCTION SetToolTip				(hWnd, hControl, hTT, text$)
DECLARE FUNCTION GetSaveName$			(filter$, defExt$, pHook, iDlg)
DECLARE FUNCTION saveExtHook			(hWnd, msg, wParam, lParam)
'APP functions
DECLARE FUNCTION Initialise				()
DECLARE FUNCTION StartIdling			()
DECLARE FUNCTION StartMotion			()
DECLARE FUNCTION StartRecording		()
DECLARE FUNCTION StopMotion				()
DECLARE FUNCTION StopRecording		()
DECLARE FUNCTION StopEverything		()
DECLARE FUNCTION motion_Reset			(cbFrame)
DECLARE FUNCTION motion						(addrBuffer)
DECLARE FUNCTION SetStatus				(newStatus)
DECLARE FUNCTION WriteFrame				(pBuffer, cbBuffer)
DECLARE FUNCTION makeThumbnail		(id)
DECLARE FUNCTION WriteIndex				()
DECLARE FUNCTION DateStamp				(FILETIME fileTime, addrBuffer, width, extrams)
DECLARE FUNCTION getOldestFile		(exclude)
'buffer managing functions
DECLARE FUNCTION initWriteBuffer	(cbFrame)
DECLARE FUNCTION writeWriteBuffer	(param)
DECLARE FUNCTION freeWriteBuffer	()
DECLARE FUNCTION initReadBuffer		(frameSize, fileNum, frames, totalFrames)
DECLARE FUNCTION getFrame					(frame)
DECLARE FUNCTION readNextBuffer		(pMem)
DECLARE FUNCTION freeReadBuffer		()
'Dlg and Window Procs
DECLARE FUNCTION WndProc					(hwnd, msg, wParam, lParam)
DECLARE FUNCTION ThumbListProc		(hwnd, msg, wParam, lParam)
DECLARE FUNCTION ViewProc					(hwnd, msg, wParam, lParam)
DECLARE FUNCTION ConfigTimerDlg		(hDlg, msg, wParam, lParam)
DECLARE FUNCTION ConfigMoniterDlg	(hDlg, msg, wParam, lParam)
DECLARE FUNCTION ConfigMotionDlg	(hDlg, msg, wParam, lParam)
DECLARE FUNCTION ConfigDlg				(hDlg, msg, wParam, lParam)
DECLARE FUNCTION SelectDeviceDlg	(hDlg, msg, wParam, lParam)
DECLARE FUNCTION ConfigDeviceDlg	(hDlg, msg, wParam, lParam)
'frame processing callbacks
DECLARE FUNCTION frameCallBack		(hWnd, lpVHdr)
DECLARE FUNCTION frameMotionCallback(hWnd, lpVHdr)
DECLARE FUNCTION frameMotionFoundCallback(hWnd, lpVHdr)
'data access functions
DECLARE FUNCTION fileIndex_Add		(FILENAME fileName)
DECLARE FUNCTION fileIndex_Get		(id, FILENAME @fileName)
DECLARE FUNCTION fileIndex_Update	(id, FILENAME fileName)
DECLARE FUNCTION fileIndex_Delete	(id)
'Auxilary functions
DECLARE FUNCTION myPower					(n)
DECLARE FUNCTION SetBPixel				(addrBuffer, x, y, UBYTE r, UBYTE g, UBYTE b)
DECLARE FUNCTION RGBQUAD getPixel	(addrBuffer, x, y)
DECLARE FUNCTION GreaterThan			(FILETIME ft1, FILETIME ft2)
DECLARE FUNCTION LessThan 				(FILETIME ft1, FILETIME ft2)
DECLARE FUNCTION ReadRegKeyString$(key$, value$, default$)
DECLARE FUNCTION WriteRegKeyString(Key$, Value$, Var$)
DECLARE FUNCTION ReadRegKey				(key$, value$, Default)
DECLARE FUNCTION WriteRegKey			(Key$, Value$, Var)
DECLARE FUNCTION SetToolTipText		(addrTOOLTIPTEXT, text$)


'shared strings
SHARED	STRING	saveLocation
'
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	IFF Initialise() THEN QUIT(0)			' initialise the app
	MessageLoop ()										' the main message loop
	CleanUp ()												' unregister all window classes

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()
	SHARED	GUIINFO	GuiInfo
	SHARED hInst
	
	INITCOMMONCONTROLSEX icc
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	icc.dwSize = SIZE(INITCOMMONCONTROLSEX)
	icc.dwICC = $$ICC_BAR_CLASSES|$$ICC_DATE_CLASSES|$$ICC_LISTVIEW_CLASSES|$$ICC_PROGRESS_CLASS|$$ICC_TAB_CLASSES|$$ICC_UPDOWN_CLASS|$$ICC_USEREX_CLASSES|$$ICC_WIN95_CLASSES

	InitCommonControlsEx (&icc)					' initialize comctl32.dll library

	GuiInfo.capWidth = 320
	GuiInfo.capHeight = 240
	GuiInfo.viewWidth = 320
	GuiInfo.viewHeight = 240

END FUNCTION
'
'
' #################################
' #####  RegisterWinClass ()  #####
' #################################
'
FUNCTION RegisterWinClass (className$, addrWndProc, icon, menu)

	SHARED hInst
	WNDCLASS wc

	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, icon)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = menu
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

' register window class
	className$  = "ThiefAwareMainWndClass"
	addrWndProc = &WndProc()
	icon 				= $$ICON_MAIN
	menu 				= 0
	IF RegisterWinClass (className$, addrWndProc, icon, menu) THEN RETURN ($$TRUE)
	IF RegisterWinClass ("ThiefAwareListClass", &ThumbListProc(), 0, 0) THEN RETURN ($$TRUE)
	IF RegisterWinClass ("ThiefAwareViewClass", &ViewProc(), 0, 0) THEN RETURN ($$TRUE)

' create main window
	titleBar$ = "ThiefAware"
	style 		= $$WS_OVERLAPPEDWINDOW
	w 				= 100
	h 				= 100
	exStyle		= 0
	#winMain = NewWindow (@className$, @titleBar$, style, x, y, w, h, exStyle)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)
	

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)

	SHARED hInst

	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
'
' ########################
' #####  CleanUp ()  #####
' ########################
'
FUNCTION CleanUp ()

	SHARED hInst, className$
	SHARED	APPSTATE	AppState

	UnregisterClassA (&className$, hInst)
	
	'wait for the write thread to finish writing
	DO WHILE ULONGAT(AppState.pWriteCommBlock)
	LOOP
	'kill it
	TerminateThread (AppState.hWriteThread, 0)
	'and free its memmory
	GlobalFree (AppState.pWriteCommBlock)
	
	'wait for the read thread to finish
	DO WHILE ULONGAT(AppState.pReadCommBlock)
	LOOP
	'kill it
	TerminateThread (AppState.hReadThread, 0)
	'and free its memmory
	GlobalFree (AppState.pReadCommBlock)

END FUNCTION
'
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION
'
' ##########################
' #####  MainOnCreate  #####
' ##########################
' Configures the main window
' hWnd = handle to the main window
' returns 0 on success or 1 on fail
FUNCTION MainOnCreate (hWnd)
	SHARED	hInst
	SHARED	GUIINFO	GuiInfo

	TOOLINFO tool
	TC_ITEM tci	
	RECT	rect
	RECT	sb
	
	'make the tooltips
	GuiInfo.hMainToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hWnd, 0, hInst, 0)
	SetWindowPos(GuiInfo.hMainToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
	tool.cbSize = SIZE(TOOLINFO)
	tool.uFlags = $$TTF_SUBCLASS|$$TTF_IDISHWND
	tool.hwnd = hWnd
	tool.hinst = hInst
	
	'start with the status bar
	GuiInfo.hStatusBar =  CreateStatusWindowA ($$WS_CHILD|$$WS_VISIBLE|$$SBARS_SIZEGRIP, &"Initialising", hWnd, $$MAIN_STB)
	IFZ GuiInfo.hStatusBar
		MessageBoxA (0, &"Cannot create status bar", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	
	'now add the tab control
	GetClientRect (hWnd, &rect)
	GetWindowRect (GuiInfo.hStatusBar, &sb)
	
	GuiInfo.hTabs = NewChild ($$WC_TABCONTROL, "", $$WS_VISIBLE|$$WS_CHILD|$$WS_CLIPSIBLINGS|$$TCS_TOOLTIPS|$$WS_TABSTOP|$$WS_GROUP, rect.left, rect.top, rect.right, rect.bottom-sb.bottom+sb.top, hWnd, $$MAIN_TABS, 0)
	IFZ GuiInfo.hTabs
		MessageBoxA (0, &"Cannot create tabs", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hTabs, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)

	DIM Labels$[1]
	Labels$[0] = "Record\0"
	Labels$[1] = "Review\0"
	
	FOR i = 0 TO 1
		tci.mask 				= $$TCIF_TEXT
		tci.pszText 		= &Labels$[i]
		tci.cchTextMax 	= LEN(Labels$[i])
		SendMessageA (GuiInfo.hTabs, $$TCM_INSERTITEM, i, &tci)				
	NEXT
	
	GuiInfo.currentTab = $$PAGE_RECORD
	
	GetClientRect (GuiInfo.hTabs, &rect)
	SendMessageA (GuiInfo.hTabs, $$TCM_ADJUSTRECT, $$FALSE, &rect)
	
	'now we'll create the controls for the record pane
	'first up, the buttons
	gap = (rect.right-rect.left-200)\3
	
	GuiInfo.hSnapButton = NewChild ("Button", "Record", $$BS_DEFPUSHBUTTON|$$WS_TABSTOP|$$WS_GROUP, rect.left+gap, rect.bottom-28, 100, 24, hWnd, $$RECORD_SNAP, 0)
	IFZ GuiInfo.hSnapButton
		MessageBoxA (0, &"Cannot create Snap! button", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hSnapButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	GuiInfo.hConfigButton = NewChild ("Button", "Configure", $$BS_PUSHBUTTON|$$WS_TABSTOP|$$WS_GROUP, rect.left+100+2*gap, rect.bottom-28, 100, 24, hWnd, $$RECORD_CONFIG, 0)
	IFZ GuiInfo.hConfigButton
		MessageBoxA (0, &"Cannot create Configure button", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hConfigButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	'and now, the capture window
	GuiInfo.hCap = capCreateCaptureWindowA (&"CapWin", $$WS_VISIBLE|$$WS_CHILD, rect.left+2+((rect.right-rect.left-4)\2)-(GuiInfo.capWidth\2), rect.top+2+((rect.bottom-rect.top-32)\2)-(GuiInfo.capHeight\2), GuiInfo.capWidth, GuiInfo.capHeight,hWnd, $$RECORD_CAPTURE)
	IFZ GuiInfo.hStatusBar
		MessageBoxA (0, &"Cannot create capture window", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hCap, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	'oki dok, now time for the review pane
	'the list panel
	GuiInfo.hList = NewChild ("ThiefAwareListClass", "ListWin", $$WS_TABSTOP|$$WS_VSCROLL|$$WS_GROUP, rect.left, rect.top, 120, rect.bottom-rect.top, hWnd, $$REVIEW_LIST, 0)
	IFZ GuiInfo.hStatusBar
		MessageBoxA (0, &"Cannot create list window", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hList, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	'the bottom row of buttons
	gap = (rect.right-rect.left-420)\4
	GuiInfo.hSavePicButton = NewChild ("Button", "Save Picture", $$BS_DEFPUSHBUTTON|$$WS_TABSTOP|$$WS_GROUP, rect.left+120+gap, rect.bottom-28, 100, 24, hWnd, $$REVIEW_BT_SAVEPIC, 0)
	IFZ GuiInfo.hStatusBar
		MessageBoxA (0, &"Cannot create Save Picture", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hSavePicButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
'	GuiInfo.hSaveMovieButton = NewChild ("Button", "Save Movie", $$BS_PUSHBUTTON|$$WS_TABSTOP|$$WS_GROUP, rect.left+220+2*gap, rect.bottom-28, 100, 24, hWnd, $$REVIEW_BT_SAVEMOV, 0)
'	IFZ GuiInfo.hStatusBar
'		MessageBoxA (0, &"Cannot create Save Movie button", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
'		RETURN 1
'	END IF
'	SendMessageA (GuiInfo.hSaveMovieButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	GuiInfo.hDeleteButton = NewChild ("Button", "Delete Footage", $$BS_PUSHBUTTON|$$WS_TABSTOP|$$WS_GROUP, rect.left+320+3*gap, rect.bottom-28, 100, 24, hWnd, $$REVIEW_BT_DELETE, 0)
	IFZ GuiInfo.hStatusBar
		MessageBoxA (0, &"Cannot create Delete Footage button", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hDeleteButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	'the viewer window
	GuiInfo.hView = NewChild ("ThiefAwareViewClass", "ViewWin", $$WS_TABSTOP|$$WS_GROUP, rect.left+120+((rect.right-rect.left-120-GuiInfo.viewWidth)\2), rect.top+((rect.bottom-rect.top-GuiInfo.viewHeight-82)\2), GuiInfo.viewWidth, GuiInfo.viewHeight+50, hWnd, $$REVIEW_VIEW, 0)
	IFZ GuiInfo.hStatusBar
		MessageBoxA (0, &"Cannot create View Window", &"Critical Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN 1
	END IF
	SendMessageA (GuiInfo.hView, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
	
	'set the tooltips
	tool.uId = GuiInfo.hSnapButton
	tool.lpszText = $$LPSTR_TEXTCALLBACK
	SendMessageA (GuiInfo.hMainToolTips, $$TTM_ADDTOOL, 0, &tool)
	
	tool.uId = GuiInfo.hConfigButton
	tool.lpszText = &"Configure the recording system"
	SendMessageA (GuiInfo.hMainToolTips, $$TTM_ADDTOOL, 0, &tool)
	
	tool.uId = GuiInfo.hSavePicButton
	tool.lpszText = &"Save this image"
	SendMessageA (GuiInfo.hMainToolTips, $$TTM_ADDTOOL, 0, &tool)
	
	tool.uId = GuiInfo.hDeleteButton
	tool.lpszText = &"Permanently delete this footage now"
	SendMessageA (GuiInfo.hMainToolTips, $$TTM_ADDTOOL, 0, &tool)

	'now hide the review pane
	showHidePage ($$PAGE_REVIEW, $$FALSE)

	'and we're all done
	RETURN 0
END FUNCTION
'
' ##########################
' #####  showHidePage  #####
' ##########################
' Use to show or hide a tab
' page = the poage to show or hide
' show = $$TRUE to show, $$FALSE to hide
' returns $$TRUE on success or $$FALSE on fail
FUNCTION showHidePage (page, show)
	SHARED	GUIINFO	GuiInfo
	SHARED	ahClipButtons[]
	
	IF show THEN show = $$SW_SHOW ELSE show = $$SW_HIDE
	SELECT CASE page
		CASE $$PAGE_RECORD
			ShowWindow (GuiInfo.hCap, show)
			ShowWindow (GuiInfo.hSnapButton, show)
			ShowWindow (GuiInfo.hConfigButton, show)
		CASE $$PAGE_REVIEW
			ShowWindow (GuiInfo.hList, show)
			ShowWindow (GuiInfo.hView, show)
			ShowWindow (GuiInfo.hSavePicButton, show)
'			ShowWindow (GuiInfo.hSaveMovieButton, show)
			ShowWindow (GuiInfo.hDeleteButton, show)
		CASE ELSE
			RETURN $$FALSE
	END SELECT
END FUNCTION
'
' ########################
' #####  sizeCapWin  #####
' ########################
' Makes sure the capture window is the right size
FUNCTION sizeCapWin ()
	SHARED	GUIINFO	GuiInfo
	
	BITMAPINFOHEADER	bmih

	'first, get the bmi
	s = SendMessageA (GuiInfo.hCap, $$WM_CAP_GET_VIDEOFORMAT, 0, 0)
	bmi$ = NULL$(s)
	SendMessageA (GuiInfo.hCap, $$WM_CAP_GET_VIDEOFORMAT, s, &bmi$)

	'now get the header
	pStruc = &bmih
	XLONGAT(&&bmih) = &bmi$
	'and update the width and height
	GuiInfo.capWidth = bmih.biWidth
	GuiInfo.capHeight = bmih.biHeight
	XLONGAT(&&bmih) = pStruc
	
	updatePositions ()
	
END FUNCTION
'
' #############################
' #####  updatePositions  #####
' #############################
' Updates the positions of the controls on the main window
FUNCTION updatePositions ()
	RECT	rect
	MINMAXINFO	mmi
	
	'and finnaly, resize
	SendMessageA (#winMain, $$WM_GETMINMAXINFO, 0, &mmi) 
	GetWindowRect (#winMain, &rect)
	IF ((rect.right-rect.left) < mmi.ptMinTrackSize.x) || ((rect.bottom-rect.top) < mmi.ptMinTrackSize.y) THEN
		SetWindowPos (#winMain, 0, 0, 0, mmi.ptMinTrackSize.x, mmi.ptMinTrackSize.y, $$SWP_NOACTIVATE|$$SWP_NOMOVE|$$SWP_NOOWNERZORDER|$$SWP_NOZORDER)
		'sizeMainControls (#winMain, mmi.ptMinTrackSize.x, mmi.ptMinTrackSize.y)
	ELSE
		GetClientRect (#winMain, &rect)
		sizeMainControls (#winMain, rect.right-rect.left, rect.bottom-rect.top)
	END IF
END FUNCTION
'
' ##############################
' #####  sizeMainControls  #####
' ##############################
' resizes the controls on the main window
FUNCTION sizeMainControls (hWnd, w, h)
	SHARED	GUIINFO	GuiInfo
	
	RECT rect
	RECT rect2
	
	'pass the message on to the status bar
	SendMessageA (GuiInfo.hStatusBar, $$WM_SIZE, ((h AND 0x0000FFFF)<<16)|(w AND 0x0000FFFF), $$SIZE_RESTORED)
	
	'now do the tabs
	GetWindowRect (GuiInfo.hStatusBar, &rect2)
	MoveWindow (GuiInfo.hTabs, 0, 0, w, h+rect2.top-rect2.bottom, $$FALSE)
	
	'and now the tab pages
	GetClientRect (GuiInfo.hTabs, &rect)
	SendMessageA (GuiInfo.hTabs, $$TCM_ADJUSTRECT, $$FALSE, &rect)
	
	'starting with the recording page
	gap = (rect.right-rect.left-200)\3
	MoveWindow (GuiInfo.hSnapButton, rect.left+gap, rect.bottom-28, 100, 24, $$FALSE)
	MoveWindow (GuiInfo.hConfigButton, rect.left+100+2*gap, rect.bottom-28, 100, 24, $$FALSE)
	MoveWindow (GuiInfo.hCap, rect.left+2+((rect.right-rect.left-4)\2)-(GuiInfo.capWidth\2), rect.top+2+((rect.bottom-rect.top-32)\2)-(GuiInfo.capHeight\2), GuiInfo.capWidth, GuiInfo.capHeight, $$FALSE)
	
	'now the review pane
	MoveWindow (GuiInfo.hList, rect.left, rect.top, 120, rect.bottom-rect.top, $$FALSE)
	gap = (rect.right-rect.left-320)\3
	MoveWindow (GuiInfo.hSavePicButton, rect.left+120+gap, rect.bottom-28, 100, 24, $$FALSE)
'	MoveWindow (GuiInfo.hSaveMovieButton, rect.left+220+2*gap, rect.bottom-28, 100, 24, $$FALSE)
	MoveWindow (GuiInfo.hDeleteButton, rect.left+220+2*gap, rect.bottom-28, 100, 24, $$FALSE)
	MoveWindow (GuiInfo.hView, rect.left+120+((rect.right-rect.left-120-GuiInfo.viewWidth)\2), rect.top+((rect.bottom-rect.top-GuiInfo.viewHeight-82)\2), GuiInfo.viewWidth, GuiInfo.viewHeight+50, $$FALSE)
	
	GetClientRect (hWnd, &rect)
	InvalidateRect (hWnd, &rect, $$FALSE)
END FUNCTION
'
' ########################
' #####  SetToolTip  #####
' ########################
' Sets up a tooltip
' hWnd = handle to the parent window of the tool
' hControl = handle to control
' hTT = handle to the tooltips
' text$ = the text for the tooltip
' returns hTT
FUNCTION SetToolTip (hWnd, hControl, hTT, text$)
	SHARED hInst

	TOOLINFO	ti

	ti.cbSize	=	SIZE(TOOLINFO)
	ti.uFlags = $$TTF_SUBCLASS|$$TTF_IDISHWND
	ti.hwnd		= hWnd
	ti.hinst	= hInst
	
	ti.uId			= hControl
	ti.lpszText	= &text$
	SendMessageA (hTT, $$TTM_ADDTOOL, 0, &ti)

	RETURN hTT
END FUNCTION
'
' #########################
' #####  GetSaveName  #####
' #########################
' Gets the name for a file to be save
' filter$ = the filter string (<description>"\0"<filter>[";"<filter>]+"\0")+"\0"
' defExt$ = the default extension
' pHook = a pointer to a hook procedure
' iDlg = the id of the dialog to customise the save file dialog
' if pHook is 0, no customisations are used
' returns the filename or an empty string on fail
FUNCTION GetSaveName$ (filter$, defExt$, pHook, iDlg)
	SHARED hInst
	OPENFILENAME	ofn
	
	ret$ = NULL$(4096)
	ofn.lStructSize = SIZE(OPENFILENAME)
	ofn.hwndOwner = #winMain
	ofn.lpstrFilter = &filter$
	ofn.lpstrFile = &ret$
	ofn.nMaxFile = LEN(ret$)
	ofn.lpstrDefExt = &defExt$
	IF pHook THEN
		ofn.hInstance = hInst
		ofn.lpfnHook = pHook
		ofn.lpTemplateName = iDlg
		ofn.flags = $$OFN_PATHMUSTEXIST|$$OFN_OVERWRITEPROMPT|$$OFN_ENABLEHOOK|$$OFN_ENABLETEMPLATE|$$OFN_EXPLORER|$$OFN_HIDEREADONLY
	ELSE
		ofn.flags = $$OFN_PATHMUSTEXIST|$$OFN_OVERWRITEPROMPT|$$OFN_HIDEREADONLY
	END IF
	
	IF GetSaveFileNameA (&ofn) THEN RETURN CSTRING$(&ret$) ELSE RETURN ""
END FUNCTION
'
' #########################
' #####  saveExtHook  #####
' #########################
' A hook procedure to extend the save file dialog box
FUNCTION saveExtHook (hWnd, msg, wParam, lParam)
	SHARED 		hInst
	SHARED	APPSTATE	AppState
	
	SELECT CASE msg
		CASE $$WM_INITDIALOG
			IF AppState.dateStamp THEN
				SendDlgItemMessageA (hWnd, $$DLG_SAVEEXT_CHK_STAMP, $$BM_SETCHECK, $$BST_CHECKED, 0)
			ELSE
				SendDlgItemMessageA (hWnd, $$DLG_SAVEEXT_CHK_STAMP, $$BM_SETCHECK, $$BST_UNCHECKED, 0)
			END IF
			
		CASE $$WM_NOTIFY
			GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)			' get info from first NMHDR struct
			SELECT CASE code
				CASE $$CDN_FILEOK
					IF SendDlgItemMessageA (hWnd, $$DLG_SAVEEXT_CHK_STAMP, $$BM_GETCHECK, 0, 0) = $$BST_CHECKED THEN
						AppState.dateStamp = $$TRUE
					ELSE
						AppState.dateStamp = $$FALSE
					END IF
			END SELECT
			
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' ########################
' #####  Initialise  #####
' ########################
' Initialises the application
' returns $$TRUE on success or $$FALSE on fail
FUNCTION Initialise ()
	SHARED	hInst
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	SHARED	STRING	saveLocation
	SHARED	FILENAME	fileIndex[]
	
	FILEINDEXHEADER	fileIndexHeader
	FILENAME	fileName
	RECT	rect
	
	'prepare the thread comm blocks
	AppState.pWriteCommBlock = GlobalAlloc ($$GPTR, 20)
	'pMem[0] = working
	'pMem[4] = fileNum
	'pMem[8] = pBuffer
	'pMem[12] = cbBuffer
	'pMem[16] = hEvent
	AppState.pReadCommBlock = GlobalAlloc ($$GPTR, 28)
	'pMem[0] = working
	'pMem[4] = filePos
	'pMem[8] = fileNum
	'pMem[12] = pBuffer
	'pMem[16] = cbBuffer
	'pMem[20] = hEvent
	'pMem[24] = filePosHigh
	
	'make the events
	ULONGAT(AppState.pWriteCommBlock, 16) = CreateEventA (0, $$FALSE, $$FALSE, &"writeEvent")
	ULONGAT(AppState.pReadCommBlock, 20) = CreateEventA (0, $$FALSE, $$FALSE, &"readEvent")
	IFZ ULONGAT(AppState.pWriteCommBlock, 16) || ULONGAT(AppState.pReadCommBlock, 20) THEN
		MessageBoxA (0, &"Cannot create events", &"error", $$MB_OK|$$MB_ICONERROR)
		QUIT(0)
	END IF
	
	'initialise the threads
	AppState.hWriteThread = CreateThread (0, 0, &writeWriteBuffer (), AppState.pWriteCommBlock, 0, &threadId)
	AppState.hReadThread = CreateThread (0, 0, &readNextBuffer (), AppState.pReadCommBlock, 0, &threadId)
	IFZ AppState.hWriteThread || AppState.hReadThread THEN
		MessageBoxA(0, &"Cannot create threads", &"error", $$MB_OK|$$MB_ICONERROR)
		QUIT(0)
	END IF
	
	'now initialise the device
	'get the device ID
	AppState.devID = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "devID", 0xFFFFFFFF)
	IF AppState.devID = 0xFFFFFFFF THEN	'the user needs to select configure a device
		'let the user select a device
		AppState.devID = DialogBoxParamA (hInst, $$DLG_DEVSELECT, #winMain, &SelectDeviceDlg(), 0)
		IF AppState.devID = 0xFFFFFFFF THEN
			MessageBoxA(#winMain, &"There is no compatable harware installed on this system\r\nYou will not be able to use recording mode", &"Error", $$MB_OK|$$MB_ICONERROR)
			cannotInit = $$TRUE
		ELSE
			'connect the device
			GOSUB Connect
			'give the user a chance to configure the device
			DialogBoxParamA (hInst, $$DLG_DEVCONFIG, #winMain, &ConfigDeviceDlg(), 0)
			'and write out the info
			WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "devID", AppState.devID)
			sizeCapWin ()
		END IF
	ELSE
		'and connect the device
		GOSUB Connect
		IFF cannotInit THEN sizeCapWin ()
	END IF
	
	UpdateWindow (#winMain)
	
	'get the rest of the settings
	AppState.timerStart = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "timerStart", 0x00060000)
	AppState.timerEnd = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "timerEnd", 0x00120000)
	AppState.moniterMode = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "monMode", $$MONMODE_MODETECT)
	AppState.frameInt = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "frameInt", 0x000000C8)
	AppState.showRecIcon = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "showRecIcon", 0x00000001)
	AppState.dateStamp = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "dateStamp", 0x00000001)
	AppState.useTimer = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "useTimer", 0x00000001)
	AppState.spaceLimit = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "spaceLimit", 0x1E00000)
	AppState.GSpaceLimit = GIANT(GIANT(AppState.spaceLimit) * GIANT(1024))
	AppState.motionSettings.sampleInt = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "sampleInt", 0x000007D0)
	AppState.motionSettings.blockSize = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "blockSize", 0x00000004)
	AppState.motionSettings.tolerance = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "tolerance", 0x00000020)
	AppState.motionSettings.toCapCount = ReadRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "toCapCount", 0x0000012C)
	SetStatus($$STATUS_WAITING)

	SendMessageA (GuiInfo.hStatusBar, $$SB_SETTEXT, 0, &"Generating thumbnails")	
	UpdateWindow (#winMain)
	
	GetClientRect (GuiInfo.hList, &rect)
	AppState.thumbWidth = rect.right-rect.left

	'get the index file
	saveLocation = ReadRegKeyString$ ("Software\\Callumscode\\ThiefAware\\1.00", "saveLocation", "C:\\ThiefAwareData")
	'make sure the folder exists
	IF XstChangeDirectory(saveLocation) THEN XstMakeDirectory(saveLocation)	'make sure the folder exists
	SpyCamIndex = OPEN (saveLocation+"\\SpyCamIndex.dat", $$RD)

	'assume there are no clips
	AppState.usedSpace = 0

	IF SpyCamIndex = -1 THEN
		GOSUB MakeNewSpyCamIndex
	ELSE
		'now read in the index
		READ[SpyCamIndex], fileIndexHeader
		IF fileIndexHeader.magic = "SPCI" THEN
			IF fileIndexHeader.version = 0x01000000 THEN
				DIM fileIndex[fileIndexHeader.recordCount*2]
				FOR i = 0 TO fileIndexHeader.recordCount-1
					READ[SpyCamIndex], fileName
					fileIndex[i] = fileName
					IF fileName.width > GuiInfo.viewWidth THEN GuiInfo.viewWidth = fileName.width
					IF fileName.height > GuiInfo.viewHeight THEN GuiInfo.viewHeight = fileName.height
					AppState.usedSpace = AppState.usedSpace + fileName.size
					'add a thumbnail
					SendMessageA (GuiInfo.hList, $$THLM_ADDCLIP, makeThumbnail (i), i)
				NEXT
			ELSE
				GOSUB fileBad
			END IF
		ELSE
			GOSUB fileBad
		END IF
	END IF
	CLOSE(SpyCamIndex)
	
	'load up the resources
	AppState.hRawFont = LoadResource (hInst, FindResourceA (hInst, $$RAW_FONT, $$RT_RCDATA))
	
	'make sure the controls are properly placed
	updatePositions ()
	
	IF cannotInit THEN
		'switch to review mode and STAY THERE
		SetStatus($$STATUS_REVIEW)
		showHidePage ($$PAGE_RECORD, $$FALSE)
		showHidePage ($$PAGE_REVIEW, $$TRUE)
		SendMessageA (GuiInfo.hTabs, $$TCM_DELETEALLITEMS, 0, 0)
		updatePositions ()
	ELSE
		'start idling
		StartIdling ()
	END IF
	
	'and we're done
	RETURN $$TRUE
	
	SUB Connect
		IFF SendMessageA (GuiInfo.hCap, $$WM_CAP_DRIVER_CONNECT, AppState.devID, 0) THEN
			MessageBoxA (#winMain, &"Cannot connect device\r\nYou will not be able to use recording mode", &"Device Error", $$MB_OK|$$MB_ICONSTOP)
			cannotInit = $$TRUE
		END IF
	END SUB
	
	SUB fileBad
		IF MessageBoxA (#winMain, &"Index file corrput, rebuild?", &"Error", $$MB_YESNO|$$MB_ICONEXCLAMATION) = $$IDYES THEN 
			CLOSE(SpyCamIndex)
			GOSUB MakeNewSpyCamIndex
		ELSE
			RETURN $$FALSE
		END IF
	END SUB
	
	SUB MakeNewSpyCamIndex
		SpyCamIndex = OPEN (saveLocation+"\\SpyCamIndex.dat", $$RWNEW)
		DIM fileIndex[0]
		fileIndexHeader.magic = "SPCI"
		fileIndexHeader.version = 0x01000000
		fileIndexHeader.recordCount = 0
		WRITE[SpyCamIndex], fileIndexHeader
		CLOSE(SpyCamIndex)
	END SUB
END FUNCTION
'
' #########################
' #####  StartIdling  #####
' #########################
' Starts the system idling
FUNCTION StartIdling ()
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	
	'disable callbacks
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_CALLBACK_FRAME, 0, 0)
	'set the idling framerate
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEWRATE, $$IDLEFRAMEINT, 0)
	'enable preview
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEW, $$TRUE, 0)
	
	SetTimer (#winMain, $$MAIN_TIMER, 1000, 0)
	SetStatus($$STATUS_IDLING)
END FUNCTION
'
' #########################
' #####  StartMotion  #####
' #########################
' Starts the motion detector
FUNCTION StartMotion ()
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	
	'reset the detector
	motion_Reset (GuiInfo.capWidth*GuiInfo.capHeight*3)
	
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_CALLBACK_FRAME, 0, &frameMotionCallback())
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEWRATE, AppState.motionSettings.sampleInt, 0)
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEW, $$TRUE, 0)
	
	SetStatus($$STATUS_MONITERING)
END FUNCTION
'
' ############################
' #####  StartRecording  #####
' ############################
' Starts the recording system
' returns $$TRUE on success or $$FALSE on fail
FUNCTION StartRecording ()
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	
	SHARED	STRING	saveLocation

	FILENAME	fileName
	SYSTEMTIME	sysTime
	
	'generate a FILENAME
	GetLocalTime (&sysTime)
	fileName.name = FORMAT$ ("####", sysTime.wYear)+FORMAT$ ("##", sysTime.wMonth)+ _
	FORMAT$ ("##", sysTime.wDay)+FORMAT$ ("##", sysTime.wHour)+FORMAT$ ("##", sysTime.wMinute)+ _
	FORMAT$ ("##", sysTime.wSecond)
	
	'replace spaces with 0s
	FOR i = 0 TO 13
		IF fileName.name{i} = ' ' THEN UBYTEAT(&fileName.name, i) = '0'
	NEXT
	
	fileName.width = GuiInfo.capWidth
	fileName.height = GuiInfo.capHeight
	SystemTimeToFileTime (&sysTime, &fileName.fileTime)
	fileName.frameInt = AppState.frameInt
	fileName.size = 0
	
	SELECT CASE AppState.moniterMode
		CASE $$MONMODE_TIMELAPSE
			UBYTEAT(&fileName.name, 14) = 'S'
			GOSUB Prepare
			
			SetStatus($$STATUS_RECORDING)
			'register the callback
			SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_CALLBACK_FRAME, 0, &frameCallBack())
		CASE $$MONMODE_MODETECT
			UBYTEAT(&fileName.name, 14) = 'M'
			GOSUB Prepare
			
			SetStatus($$STATUS_MOFOUND)
			'register the callback
			SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_CALLBACK_FRAME, 0, &frameMotionFoundCallback())
			
			'do some additional setup
			AppState.motionSettings.toCapture = AppState.motionSettings.toCapCount
			motion_Reset (GuiInfo.capWidth*GuiInfo.capHeight*3)
	END SELECT
	
	initWriteBuffer (GuiInfo.capWidth*GuiInfo.capHeight*3)
	
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEWRATE, AppState.frameInt, 0)
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEW, $$TRUE, 0)
	
	RETURN $$TRUE
	
	SUB Prepare
		AppState.currentFrame = 0
		AppState.fileId = fileIndex_Add (fileName)
		'AppState.fileNum = OPEN(saveLocation+"\\"+fileName.name+".dat", $$RWNEW)
		'IF AppState.fileNum = -1 THEN
		'	MessageBoxA (#winMain, &"Cannot open file for recording", &"error", $$MB_OK|$$MB_ICONWARNING)
		'	RETURN $$FALSE
		'END IF
		fullFileName$ = saveLocation+"\\"+fileName.name+".dat"
		AppState.fileNum = CreateFileA (&fullFileName$, $$GENERIC_WRITE, 0, 0, $$CREATE_ALWAYS, $$FILE_ATTRIBUTE_NORMAL, 0)
		IF AppState.fileNum = $$INVALID_HANDLE_VALUE THEN
			MessageBoxA (#winMain, &"Cannot open file for recording", &"error", $$MB_OK|$$MB_ICONWARNING)
			RETURN $$FALSE
		END IF
		'ok, now write out the header
		s = SendMessageA (GuiInfo.hCap, $$WM_CAP_GET_VIDEOFORMAT, 0, 0)
		bmi$ = NULL$(s)
		SendMessageA (GuiInfo.hCap, $$WM_CAP_GET_VIDEOFORMAT, s, &bmi$)
		'XstBinWrite (AppState.fileNum, &bmi$, SIZE(BITMAPINFOHEADER))
		WriteFile (AppState.fileNum, &bmi$, SIZE(BITMAPINFOHEADER), &written, 0)
	END SUB
	
END FUNCTION
'
' ########################
' #####  StopMotion  #####
' ########################
' switches off motion detection
FUNCTION StopMotion ()
	SHARED	GUIINFO	GuiInfo
	'stop preview and disable any callbacks
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEW, $$FALSE, 0)
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_CALLBACK_FRAME, 0, 0)
	
	StartIdling ()
END FUNCTION
'
' ###########################
' #####  StopRecording  #####
' ###########################
' Stops the recording system
FUNCTION StopRecording ()
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	
	FILENAME fileName
	
	'stop preview and disable any callbacks
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEW, $$FALSE, 0)
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_CALLBACK_FRAME, 0, 0)

	freeWriteBuffer ()

	'update the frame count
	fileIndex_Get (AppState.fileId, @fileName)
	fileName.frameCount = AppState.currentFrame
	fileName.size = AppState.currentFrame*fileName.width*fileName.height*3
	fileIndex_Update (AppState.fileId, fileName)
	
	AppState.usedSpace = AppState.usedSpace + fileName.size
	
	'close the file
	'CLOSE(AppState.fileNum)
	FlushFileBuffers (AppState.fileNum)
	CloseHandle (AppState.fileNum)
	'write the index
	WriteIndex ()
	
	'and add its thumbnail to the list window
	SendMessageA (GuiInfo.hList, $$THLM_ADDCLIP, makeThumbnail (AppState.fileId), AppState.fileId)
	'and make sure the player is large enough
	IF GuiInfo.capWidth > GuiInfo.viewWidth THEN GuiInfo.viewWidth = GuiInfo.capWidth
	IF GuiInfo.capHeight > GuiInfo.viewHeight THEN GuiInfo.viewHeight = GuiInfo.capHeight
	updatePositions ()
	
	'and jump back into the appropriate mode
	SELECT CASE AppState.moniterMode
		CASE $$MONMODE_TIMELAPSE
			StartIdling ()
		CASE $$MONMODE_MODETECT
			StartMotion ()
	END SELECT
	
END FUNCTION
'
' ############################
' #####  StopEverything  #####
' ############################
' Stops whatever the system is doing
FUNCTION StopEverything ()
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo

	'if any of these are running, turn them off
	SELECT CASE AppState.status
		CASE $$STATUS_MONITERING
			StopMotion ()
		CASE $$STATUS_MOFOUND
			StopRecording ()
			StopMotion ()
		CASE $$STATUS_RECORDING
			StopRecording ()
		CASE $$STATUS_STOPPED, $$STATUS_PLAYING
			SendMessageA (GuiInfo.hView, $$VWNM_UNLOAD, 0, 0)
	END SELECT
	
	'now stop idling
	KillTimer (#winMain, $$MAIN_TIMER)
	SetStatus($$STATUS_WAITING)
	'disable preview
	SendMessageA (GuiInfo.hCap, $$WM_CAP_SET_PREVIEW, $$FALSE, 0)
	
END FUNCTION
'
' ##########################
' #####  motion_Reset  #####
' ##########################
' resets the motion detector
' cbFrame = the size of the frame buffer
FUNCTION motion_Reset (cbFrame)
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	'lots of precalculation for optimisation
	SHARED	bufferX					'width of buffer
	SHARED	bufferY					'height of buffer
	SHARED	blockSquared
	SHARED	bufferXl1
	SHARED	bufferYl1
	SHARED	bxby
	SHARED	maxBlockPixel
	SHARED	cBlockPixel
	SHARED	RGBQUAD	buffer[]	'the buffer
	SHARED	iThisFrame			'index in buffer of this frame
	SHARED	iPrevFrame			'index in buffer of previous frame
	
	blockSquared = 2*AppState.motionSettings.blockSize
	bufferX = GuiInfo.capWidth\(myPower(AppState.motionSettings.blockSize))
	bufferY = GuiInfo.capHeight\(myPower(AppState.motionSettings.blockSize))
	bufferXl1	= bufferX - 1
	bufferYl1 = bufferY -1
	bxby = bufferX*bufferY
	cBlockPixel = (myPower(AppState.motionSettings.blockSize))
	maxBlockPixel = cBlockPixel-1
	
	DIM buffer[(2*bufferX*bufferY)-1]
	
	iThisFrame = 0
	iPrevFrame = -1
END FUNCTION
'
' #########################
' #####  motion_Next  #####
' #########################
' Adds the next frame
' addrBuffer = the address of the frame buffer
' returns $$TRUE if motion is detected, $$FALSE if it isn't
FUNCTION motion (addrBuffer)
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	SHARED	bufferX					'width of buffer
	SHARED	bufferY					'height of buffer
	SHARED	blockSquared
	SHARED	bufferXl1
	SHARED	bufferYl1
	SHARED	bxby
	SHARED	maxBlockPixel
	SHARED	cBlockPixel
	SHARED	RGBQUAD	buffer[]	'the buffer
	SHARED	iThisFrame			'index in buffer of this frame
	SHARED	iPrevFrame			'index in buffer of previous frame
	
	RGBQUAD rgb
	
	'first up, write this frame into our buffer
	FOR bY = 0 TO bufferYl1
		FOR bX = 0 TO bufferXl1
			ar = 0
			ag = 0
			ab = 0
			FOR fY = 0 TO maxBlockPixel
				FOR fX = 0 TO maxBlockPixel
					rgb = getPixel(addrBuffer, (bX*cBlockPixel)+fX, (bY*cBlockPixel)+fY)
					ar = ar + rgb.red
					ag = ag + rgb.green
					ab = ab + rgb.blue
				NEXT
			NEXT
			rgb.red = ar>>blockSquared
			rgb.green = ag>>blockSquared
			rgb.blue = ab>>blockSquared
			rgb.zero = (rgb.red+rgb.green+rgb.blue)\3
			buffer[(bY*bufferX)+bX+iThisFrame] = rgb
		NEXT
	NEXT
	
	'do we need to compare?
	IF iPrevFrame != -1 THEN
		'compare
		ac = 0	'average change in the grayscale channel
		isMotion = $$FALSE
		FOR y = 0 TO bufferYl1
			FOR x = 0 TO bufferXl1
				bufferLoc = (y*bufferX)+x+iThisFrame
				oldBuffer = (y*bufferX)+x+iPrevFrame
				'poke debugging info
'				FOR bY = y*cBlockPixel TO (y*cBlockPixel)+maxBlockPixel
'					FOR bX = x*cBlockPixel TO (x*cBlockPixel)+maxBlockPixel
'						SetBPixel (addrBuffer, bX, bY, buffer[bufferLoc].red, buffer[bufferLoc].green, buffer[bufferLoc].blue)
'					NEXT
'				NEXT
				ac = ac + ABS(buffer[bufferLoc].zero - buffer[oldBuffer].zero)
				IF (ABS(buffer[bufferLoc].red - buffer[oldBuffer].red) > AppState.motionSettings.tolerance) || _
				(ABS(buffer[bufferLoc].green - buffer[oldBuffer].green) > AppState.motionSettings.tolerance) || _
				(ABS(buffer[bufferLoc].blue - buffer[oldBuffer].blue) > AppState.motionSettings.tolerance) THEN
					isMotion = $$TRUE
					GOTO doneFor
				END IF
			NEXT
		NEXT
doneFor:
		SWAP iThisFrame, iPrevFrame
		IF isMotion THEN
			'Is the change in any pixel anomalous?
			ac = ac\bxby
			FOR y = 0 TO bufferYl1
				FOR x = 0 TO bufferXl1
					IF ABS(buffer[(y*bufferX)+x+iThisFrame].zero - buffer[(y*bufferX)+x+iPrevFrame].zero) > AppState.motionSettings.tolerance THEN
						RETURN $$TRUE
					END IF
				NEXT
			NEXT
			RETURN $$TRUE
		END IF
		RETURN $$FALSE
	ELSE
		iPrevFrame = 0
		iThisFrame = bxby
		RETURN $$FALSE
	END IF
END FUNCTION
'
' #######################
' #####  SetStatus  #####
' #######################
' sets the status of the program
' newStatus = the new status
' returns $$TRUE
FUNCTION SetStatus (newStatus)
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	
	AppState.status = newStatus
	
	SELECT CASE newStatus
		CASE $$STATUS_WAITING
			SetWindowTextA (GuiInfo.hStatusBar, &"Waiting")
			SetWindowTextA (#winMain, &"ThiefAware")
			SetWindowTextA (GuiInfo.hSnapButton, &"Record")
		CASE $$STATUS_IDLING
			SetWindowTextA (GuiInfo.hStatusBar, &"Idling")
			SetWindowTextA (#winMain, &"ThiefAware")
			SetWindowTextA (GuiInfo.hSnapButton, &"Record")
		CASE $$STATUS_MONITERING
			SetWindowTextA (GuiInfo.hStatusBar, &"Monitering Motion")
			SetWindowTextA (#winMain, &"ThiefAware - monitering")
			SetWindowTextA (GuiInfo.hSnapButton, &"Record")
		CASE $$STATUS_MOFOUND
			SetWindowTextA (GuiInfo.hStatusBar, &"Motion Detected")
			SetWindowTextA (#winMain, &"ThiefAware - recording")
			SetWindowTextA (GuiInfo.hSnapButton, &"Stop")
		CASE $$STATUS_RECORDING
			SetWindowTextA (GuiInfo.hStatusBar, &"Recording")
			SetWindowTextA (#winMain, &"ThiefAware - recording")
			SetWindowTextA (GuiInfo.hSnapButton, &"Stop")
		CASE $$STATUS_REVIEW
			SetWindowTextA (GuiInfo.hStatusBar, &"Review")
			SetWindowTextA (#winMain, &"ThiefAware")
			SetWindowTextA (GuiInfo.hSnapButton, &"Record")
		CASE $$STATUS_STOPPED
			SetWindowTextA (GuiInfo.hStatusBar, &"Stopped")
			SetWindowTextA (#winMain, &"ThiefAware")
			SetWindowTextA (GuiInfo.hSnapButton, &"Record")
		CASE $$STATUS_PLAYING
			SetWindowTextA (GuiInfo.hStatusBar, &"Playing")
			SetWindowTextA (#winMain, &"ThiefAware")
			SetWindowTextA (GuiInfo.hSnapButton, &"Record")
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' ########################
' #####  WriteFrame  #####
' ########################
' Writes a frame out to the current file
' pBuffer = a pointer to the buffer
' cbBuffer = the size of the buffer in bytes
FUNCTION WriteFrame (pBuffer, cbBuffer)
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	SHARED	localBuffer		'address of the buffer
	SHARED	startIndex		'starting offset in buffer
	SHARED	halfBuffer		'the offset at which the buffer must be swapped
	SHARED	ourBuffer			'the offset to the buffer we're using
	'pMem[0] = working
	'pMem[4] = fileNum
	'pMem[8] = pBuffer
	'pMem[12] = cbBuffer
	'pMem[16] = hEvent
	
	RtlMoveMemory (localBuffer+ourBuffer+startIndex, pBuffer, cbBuffer)

	startIndex = startIndex+cbBuffer
	IF startIndex = halfBuffer THEN
		'flush the buffer
		'writeWriteBuffer (AppState.fileNum, localBuffer+ourBuffer, halfBuffer)
		
		'wait untill the thread is done
		DO WHILE ULONGAT(AppState.pWriteCommBlock)
		LOOP
		
		'first, write out the threadCommBlock
		ULONGAT(AppState.pWriteCommBlock) = $$TRUE
		ULONGAT(AppState.pWriteCommBlock, 4) = AppState.fileNum
		ULONGAT(AppState.pWriteCommBlock, 8) = localBuffer+ourBuffer
		ULONGAT(AppState.pWriteCommBlock, 12) = halfBuffer
		
		'then start executing the write thread
		'CreateThread (0, 0, &writeWriteBuffer (), threadCommBlock, 0, &threadId)
		SetEvent (ULONGAT(AppState.pWriteCommBlock, 16))
		
		'and prepare the next one
		ourBuffer = ourBuffer XOR halfBuffer
		startIndex = 0
	END IF

	INC AppState.currentFrame
	bytes = AppState.currentFrame*cbBuffer
	IF (AppState.usedSpace + bytes) > AppState.GSpaceLimit THEN
		
		'make more room
		'search for the oldest file, then delete it
		file = getOldestFile (AppState.fileId)
		DO WHILE file != -1 && (AppState.usedSpace + bytes) > AppState.GSpaceLimit
			SendMessageA (GuiInfo.hList, $$THLM_SELECTFILE, file, 0)
			SendMessageA (GuiInfo.hList, $$THLM_DELCLIP, 0, 0)
			file = getOldestFile (AppState.fileId)
		LOOP
		
		IF (AppState.usedSpace + bytes) > AppState.GSpaceLimit THEN
			'we cannot record any longer
			StopRecording ()
		END IF
	END IF
END FUNCTION
'
' ###########################
' #####  makeThumbnail  #####
' ###########################
' Generates a thumbnail
' id = the id of the FILENAME to make the thumbnail from
' returns a handle to the thumbnail bitmap or 0 on fail
FUNCTION makeThumbnail (id)
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	FILENAME	fileName
	SHARED	STRING	saveLocation
	
	BITMAPINFOHEADER bmih
	BITMAPINFOHEADER bmihT
	
	RGBQUAD	rgb
	
	'get the FILENAME
	IFF fileIndex_Get (id, @fileName) THEN RETURN 0
	
	'open the file
	fileNum = OPEN(saveLocation+"\\"+fileName.name+".dat", $$RD)
	IF fileNum = -1 THEN RETURN 0
	
	'get the bmih
	READ[fileNum], bmih

	'load the first frame
	frame$ = NULL$(bmih.biWidth*bmih.biHeight*(bmih.biBitCount>>3))
	READ[fileNum], frame$
	
	CLOSE(fileNum)

	'now make a DC and bitmap	
	hdc = GetDC (#winMain)
	hDC = CreateCompatibleDC (hdc)
	dHeight = INT((DOUBLE(AppState.thumbWidth)*DOUBLE(bmih.biHeight))/DOUBLE(bmih.biWidth))
	hBMP = CreateCompatibleBitmap (hdc, AppState.thumbWidth, dHeight)
	ReleaseDC (#winMain, hdc)

	'select in the bitmap
	hBmpOld = SelectObject (hDC, hBMP)
	
	'we need to do this manually
	'first, make a dib
	bmihT = bmih
	bmihT.biWidth = AppState.thumbWidth
	bmihT.biHeight = dHeight
	bmihT.biClrUsed = 0
	'we need padding
	IF bmihT.biWidth MOD 4 THEN scanline = (bmihT.biWidth AND 0xFFFFFFFC)+4 ELSE scanline = bmihT.biWidth
	bufferT$ = NULL$(scanline*bmihT.biHeight*3)
	
	blockH# = bmih.biWidth/AppState.thumbWidth
	blockV# = bmih.biHeight/dHeight
	block = INT(blockH#)*INT(blockH#)
	
	FOR y = 0 TO (dHeight-1)
		FOR x = 0 TO AppState.thumbWidth-1
			'get the average of all the pixels in the block
			ar = 0
			ag = 0
			ab = 0
			FOR ya = 0 TO INT(blockV#)-1
				FOR xa = 0 TO INT(blockH#)-1
					'rgb = getPixel(&frame$, INT(x*blockH#)+xa, INT(y*blockV#)+ya)
					offsetPixel = ((bmih.biHeight-1-INT(y*blockV#)-ya)*bmih.biWidth*3)+((INT(x*blockH#)+xa)*3)
					ULONGAT(&rgb) = ULONGAT(&frame$, offsetPixel)
					ar = ar + rgb.red
					ag = ag + rgb.green
					ab = ab + rgb.blue
				NEXT
			NEXT
			
			rgb.red = ar\(block)
			rgb.green = ag\(block)
			rgb.blue = ab\(block)
			
			'find the destination pixel
			pixelAddr = &bufferT$+((dHeight-1-y)*scanline*3)+(x*3)
			UBYTEAT (pixelAddr) = rgb.blue
			UBYTEAT (pixelAddr,1) = rgb.green
			UBYTEAT (pixelAddr,2) = rgb.red
		NEXT
	NEXT
	
	'set dibits
	SetDIBitsToDevice (hDC, 0, 0, AppState.thumbWidth, dHeight, 0, 0, 0, dHeight, &bufferT$, &bmihT, 0)
	
	'now delete the DC and return
	hBmp = SelectObject (hDC, hBmpOld)
	DeleteDC (hDC)
	RETURN hBmp
END FUNCTION
'
' ########################
' #####  WriteIndex  #####
' ########################
' Writes the fileIndex out to disk
FUNCTION WriteIndex ()
	SHARED	FILENAME	fileIndex[]
	SHARED	STRING	saveLocation
	
	FILENAME	outFileIndex[]
	FILEINDEXHEADER	fileIndexHeader
	FILENAME	fileName
	
	FILETIME lastMin		'the previous minimum
	
	DIM outFileIndex[UBOUND(fileIndex[])]
	
	'sort the indicies
	'at most, we'll have about 20 indicies, so lets just use a bubble sort
	
	min = -1	'the index of the next smallest FILENAME
	pos = 0	'the position in the output

	DO
		min = -1
		'assume we're done
		done = $$TRUE
		'get the minimum
		FOR i = 0 TO UBOUND(fileIndex[])
			IF fileIndex[i].recordUsed THEN
				IF GreaterThan(fileIndex[i].fileTime, lastMin) THEN
					IF min = -1 THEN
						done = $$FALSE
						min = i
					ELSE
						IF LessThan (fileIndex[i].fileTime, fileIndex[min].fileTime) THEN
							min = i
							'we're not done yet
							done = $$FALSE
						END IF
					END IF
				END IF
			END IF
		NEXT
		IF done THEN EXIT DO
		outFileIndex[pos] = fileIndex[min]
		lastMin = outFileIndex[pos].fileTime
		INC pos
	LOOP
	
	'fill out the header
	fileIndexHeader.magic = "SPCI"
	fileIndexHeader.version = 0x01000000
	fileIndexHeader.recordCount = pos	
	
	'free up the unused memmory
	REDIM outFileIndex[fileIndexHeader.recordCount-1]
	
	'now write it all out
	SpyCamIndex = OPEN (saveLocation+"\\SpyCamIndex.dat", $$RWNEW)	
	WRITE[SpyCamIndex], fileIndexHeader
	WRITE[SpyCamIndex], outFileIndex[]
	CLOSE(SpyCamIndex)
	
END FUNCTION
'
' #######################
' #####  DateStamp  #####
' #######################
' Stamps the date and time into a buffer
' fileTime = the fileTime structure to use
' addrBuffer = the buffer to write into
' width = the width of the buffer in pixels
' extrams = the number of extra milli seconds to add to the file time
' returns $$TRUE on success or $$FALSE on fail
FUNCTION DateStamp (FILETIME fileTime, addrBuffer, width, extrams)
	SHARED	APPSTATE	AppState
	SYSTEMTIME sysTime
	
	GIANT extra100ns
	
	RGBQUAD	rgb
	'compute the date and time
	
	'first, add the extra seconds
	extra100ns = extrams*10000
	GIANTAT(&fileTime) = GIANTAT(&fileTime) + extra100ns
	
	'then convert to a string
	FileTimeToSystemTime (&fileTime, &sysTime)
	
	cc = GetDateFormatA ($$LOCALE_USER_DEFAULT, $$DATE_SHORTDATE, &sysTime, 0, 0, 0)
	add$ = NULL$(cc)
	GetDateFormatA ($$LOCALE_USER_DEFAULT, $$DATE_SHORTDATE, &sysTime, 0, &add$, cc)
	dateTime$ = CSTRING$(&add$)
	cc = GetTimeFormatA ($$LOCALE_USER_DEFAULT, $$TIME_FORCE24HOURFORMAT, &sysTime, 0, 0, 0)
	add$ = NULL$(cc)
	GetTimeFormatA ($$LOCALE_USER_DEFAULT, 0, &sysTime, 0, &add$, cc)
	dateTime$ = dateTime$+" "+CSTRING$(&add$)
	
	'where is the starting x pixel
	start = width - (LEN(dateTime$)*8)
	IF start < 0 THEN RETURN $$FALSE
	
	'turn the string into an array
	DIM readFrom[LEN(dateTime$)-1]
	FOR i = 0 TO UBOUND(readFrom[])
		IF dateTime${i} >= '0' && dateTime${i} <= '9' THEN
			readFrom[i] = (dateTime${i}-'0')*8
		ELSE
			SELECT CASE dateTime${i}
				CASE ' '
					readFrom[i] = -1
				CASE '/'
					readFrom[i] = 80
				CASE ':'
					readFrom[i] = 88
				CASE 'A','a'
					readFrom[i] = 96
				CASE 'P','p'
					readFrom[i] = 104
				CASE 'M','m'
					readFrom[i] = 112
				CASE ELSE
					readFrom[i] = -1
			END SELECT
		END IF
	NEXT
	
	addrSource = LockResource (AppState.hRawFont)
	
	'now paint them on, scanline by scanline
	FOR scanline = 0 TO 11
		scanlineDestAddr = addrBuffer+(scanline*width*3)
		scanLineSourceAddr = addrSource+(scanline*360)
		
		FOR char = 0 TO UBOUND(readFrom[])
			IF readFrom[char] != -1 THEN
				FOR x = 0 TO 7
					addrDestPixel = scanlineDestAddr+3*(start+(char*8)+x)
					addrSourcePixel = scanLineSourceAddr+3*(readFrom[char]+x)
					ULONGAT(&rgb) = ULONGAT(addrSourcePixel)
					IF rgb.red || rgb.green || rgb.blue THEN
						'copy pixel
						UBYTEAT(addrDestPixel) = rgb.blue
						UBYTEAT(addrDestPixel,1) = rgb.green
						UBYTEAT(addrDestPixel,2) = rgb.red
					END IF
				NEXT
			END IF
		NEXT
	NEXT

	RETURN $$TRUE
END FUNCTION
'
' ###########################
' #####  getOldestFile  #####
' ###########################
' Gets the oldest file from the file index
' exclude is the index to exclude from the search
' returns the index of the oldest file or -1 if there are no more files
FUNCTION getOldestFile (exclude)
	SHARED	FILENAME	fileIndex[]
	
	min = -1
	'get the minimum
	FOR i = 0 TO UBOUND(fileIndex[])
		IF i != exclude && fileIndex[i].recordUsed THEN
			IF min = -1 THEN
				min = i
			ELSE
				IF LessThan (fileIndex[i].fileTime, fileIndex[min].fileTime) THEN
					min = i
				END IF
			END IF
		END IF
	NEXT
	
	RETURN min
END FUNCTION
'
' #############################
' #####  initWriteBuffer  #####
' #############################
' initialises the buffers for WriteFrame
'	cbFrame = the number of bytes in a single frame
FUNCTION initWriteBuffer (cbFrame)
	SHARED	localBuffer		'address of the buffer
	SHARED	startIndex		'starting offset in buffer
	SHARED	halfBuffer		'the offset at which the buffer must be swapped
	SHARED	ourBuffer			'the offset to the buffer we're using
	
	'DIM localBuffer[(cbFrame*25)-1]
	localBuffer = GlobalAlloc ($$GPTR, cbFrame*10)
	startIndex = 0
	halfBuffer = cbFrame*5
	ourBuffer = 0
END FUNCTION
'
' ##############################
' #####  writeWriteBuffer  #####
' ##############################
' Writes the write buffer out to disk
FUNCTION writeWriteBuffer (pMem)
	
	'get the variables out of pMem
	'pMem[0] = working
	'pMem[4] = fileNum
	'pMem[8] = pBuffer
	'pMem[12] = cbBuffer
	'pMem[16] = hEvent
	DO
		WaitForSingleObject (ULONGAT(pMem, 16), $$INFINITE)
		'XstBinWrite (ULONGAT(pMem, 4), ULONGAT(pMem, 8), ULONGAT(pMem, 12))
		IF ULONGAT(pMem, 12) != 0 THEN
			WriteFile (ULONGAT(pMem, 4), ULONGAT(pMem, 8), ULONGAT(pMem, 12), &written, 0)
		END IF
		ULONGAT(pMem) = $$FALSE
	LOOP
END FUNCTION

'
' #############################
' #####  freeWriteBuffer  #####
' #############################
' frees the write buffer
FUNCTION freeWriteBuffer ()
	SHARED	APPSTATE	AppState
	SHARED	localBuffer		'address of the buffer
	SHARED	startIndex		'starting offset in buffer
	SHARED	ourBuffer			'the offset to the buffer we're using
	
	'wait untill the thread is done
	IF localBuffer THEN
		DO WHILE ULONGAT(AppState.pWriteCommBlock)
		LOOP
		
		'first, write out the threadCommBlock
		ULONGAT(AppState.pWriteCommBlock) = $$TRUE
		ULONGAT(AppState.pWriteCommBlock, 4) = AppState.fileNum
		ULONGAT(AppState.pWriteCommBlock, 8) = localBuffer+ourBuffer
		ULONGAT(AppState.pWriteCommBlock, 12) = startIndex
		
		'then write out the buffer
		'CreateThread (0, 0, &writeWriteBuffer (), threadCommBlock, 0, &threadId)
		'writeWriteBuffer(threadCommBlock)
		SetEvent (ULONGAT(AppState.pWriteCommBlock, 16))
		
		'and wait for it to finish
		DO WHILE ULONGAT(AppState.pWriteCommBlock)
		LOOP
		
		'before freeing memmory
		GlobalFree (localBuffer)
	END IF
END FUNCTION
'
' ############################
' #####  initReadBuffer  #####
' ############################
' Resets the read buffer and loads the first frames
' frameSize = the number of bytes ina  single frame
' fileNum = the file number to attach to the buffer
' frames = the number of frames per buffer
' totalFrames = the total number of frames in the file
' returns a pointer to the first frame
FUNCTION initReadBuffer (frameSize, fileNum, frames, totalFrames)
	SHARED READINFO readInfo

	'prepare the info
	readInfo.fileNumber = fileNum
	readInfo.totalFrames = totalFrames
	readInfo.frameSize = frameSize
	readInfo.halfBuffer = frameSize*frames
	readInfo.localBuffer = GlobalAlloc ($$GPTR, readInfo.halfBuffer*2)
	readInfo.ourBuffer = 0
	readInfo.firstFrame = 0
	readInfo.framesPerBuffer = frames
	readInfo.inUse = $$TRUE
	
	'load the first frame
	'SEEK (readInfo.fileNumber, SIZE(BITMAPINFOHEADER))
	'XstBinRead (readInfo.fileNumber, readInfo.localBuffer, readInfo.halfBuffer) = -1
	'XstBinRead (readInfo.fileNumber, readInfo.localBuffer+readInfo.halfBuffer, readInfo.halfBuffer)
	
	SetFilePointer (readInfo.fileNumber, SIZE(BITMAPINFOHEADER), 0, $$FILE_BEGIN)
	ReadFile (readInfo.fileNumber, readInfo.localBuffer, readInfo.halfBuffer, &readBytes, 0)
	ReadFile (readInfo.fileNumber, readInfo.localBuffer+readInfo.halfBuffer, readInfo.halfBuffer, &readBytes, 0)
	
	'and return its pointer
	RETURN readInfo.localBuffer
END FUNCTION
'
' ######################
' #####  getFrame  #####
' ######################
' Gets a frame from the file or the buffer
' frame = the 0 based index of the frame
' returns a pointer to the frame
FUNCTION getFrame (frame)
	SHARED READINFO readInfo
	SHARED	APPSTATE	AppState

	'thread Comm block
	'pMem[0] = working
	'pMem[4] = filePos
	'pMem[8] = fileNum
	'pMem[12] = pBuffer
	'pMem[16] = cbBuffer
	'pMem[20] = hEvent
	
	'first, is the frame in this buffer
	
	IF frame >= readInfo.firstFrame THEN
		IF frame >= readInfo.firstFrame+readInfo.framesPerBuffer
			'use the next buffer
			'wait until its been read
			DO WHILE ULONGAT(AppState.pReadCommBlock)
			LOOP
				
			IF frame < readInfo.firstFrame+2*readInfo.framesPerBuffer THEN
				'use the very next buffer
				
				IF frame < readInfo.totalFrames-readInfo.framesPerBuffer THEN
					'we need to get another buffer
					
					'prepare the commblock
					filePos$$ = GIANT(GIANT(SIZE(BITMAPINFOHEADER))+(GIANT(readInfo.firstFrame)+GIANT(2)*GIANT(readInfo.framesPerBuffer))*GIANT(readInfo.frameSize))
					ULONGAT(AppState.pReadCommBlock)			= $$FALSE
					ULONGAT(AppState.pReadCommBlock, 4)		= GLOW(filePos$$)
					ULONGAT(AppState.pReadCommBlock, 8)		= readInfo.fileNumber
					ULONGAT(AppState.pReadCommBlock, 12)	= readInfo.localBuffer+readInfo.ourBuffer
					ULONGAT(AppState.pReadCommBlock, 16)	= readInfo.halfBuffer
					ULONGAT(AppState.pReadCommBlock, 24)	= GHIGH(filePos$$)
					
					'signal the read thread
					'CreateThread (0, 0, &readNextBuffer (), readInfo.threadCommBlock, 0, &threadId)
					'readNextBuffer (readInfo.threadCommBlock)
					SetEvent (ULONGAT(AppState.pReadCommBlock, 20))
				END IF
				
				'now flip the buffers
				readInfo.ourBuffer = readInfo.ourBuffer XOR readInfo.halfBuffer
				readInfo.firstFrame = readInfo.firstFrame + readInfo.framesPerBuffer
			ELSE
				'use a much later buffer
				GOSUB LoadAnyBuffer
			END IF
		END IF
	ELSE
		'we have to backtrack
		GOSUB LoadAnyBuffer
	END IF
	
	RETURN readInfo.localBuffer+readInfo.ourBuffer+(frame-readInfo.firstFrame)*readInfo.frameSize
	
	SUB LoadAnyBuffer
		'wait until its been read
		DO WHILE ULONGAT(AppState.pReadCommBlock)
		LOOP
		
		'use a much later buffer
		readInfo.ourBuffer = 0
		
		IF frame < readInfo.totalFrames-2*readInfo.framesPerBuffer THEN
			'load from frame
			readInfo.firstFrame = frame
			filePos$$ = GIANT(GIANT(SIZE(BITMAPINFOHEADER))+GIANT(frame)*GIANT(readInfo.frameSize))
			'SEEK (readInfo.fileNumber, SIZE(BITMAPINFOHEADER)+frame*readInfo.frameSize)
		ELSE
			'load the end of the file
			readInfo.firstFrame = MAX(readInfo.totalFrames-2*readInfo.framesPerBuffer,0)
			filePos$$ = GIANT(GIANT(SIZE(BITMAPINFOHEADER))+GIANT(readInfo.firstFrame)*GIANT(readInfo.frameSize))
			'SEEK (readInfo.fileNumber, SIZE(BITMAPINFOHEADER)+readInfo.firstFrame*readInfo.frameSize)
		END IF
		'and load
		SetFilePointer (readInfo.fileNumber, GLOW(filePos$$), GHIGH(filePos$$), $$FILE_BEGIN)
		ReadFile (readInfo.fileNumber, readInfo.localBuffer, readInfo.halfBuffer, &readBytes, 0)
		ReadFile (readInfo.fileNumber, readInfo.localBuffer+readInfo.halfBuffer, readInfo.halfBuffer, &readBytes, 0)
	END SUB
END FUNCTION
'
' ############################
' #####  readNextBuffer  #####
' ############################
' Reads from the file into the specified buffer
FUNCTION readNextBuffer (pMem)
	'pMem[0] = working
	'pMem[4] = filePos
	'pMem[8] = fileNum
	'pMem[12] = pBuffer
	'pMem[16] = cbBuffer
	'pMem[20] = hEvent
	'pMem[24] = filePosHigh
	
	DO
		WaitForSingleObject (ULONGAT(pMem, 20), $$INFINITE)
		ULONGAT(pMem) = $$TRUE
		'SEEK (ULONGAT(pMem, 8), ULONGAT(pMem, 4))
		SetFilePointer (ULONGAT(pMem, 8), ULONGAT(pMem, 4), ULONGAT(pMem, 24), $$FILE_BEGIN)
		'XstBinRead (ULONGAT(pMem, 8), ULONGAT(pMem, 12), ULONGAT(pMem, 16))
		ReadFile (ULONGAT(pMem, 8), ULONGAT(pMem, 12), ULONGAT(pMem, 16), &readBytes, 0)
		ULONGAT(pMem) = $$FALSE
	LOOP
END FUNCTION
'
' ############################
' #####  freeReadBuffer  #####
' ############################
' frees up the read buffer
FUNCTION freeReadBuffer ()
	SHARED	APPSTATE	AppState
	SHARED READINFO readInfo
	
	IF readInfo.inUse THEN
		'wait for the read thread
		DO WHILE ULONGAT(AppState.pReadCommBlock)
		LOOP
		
		'and deallocate
		GlobalFree(readInfo.localBuffer)
		
		readInfo.inUse = $$FALSE
	END IF
END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
' The main window
FUNCTION WndProc (hWnd, msg, wParam, lParam)
	SHARED	hInst
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	
	SYSTEMTIME sysTime
	
	MINMAXINFO	mmi
	PAINTSTRUCT ps
	RECT rect
	RECT rect2
	NMTTDISPINFO nmttdi
	
	POINTAPI	pt

	SELECT CASE msg
		
		CASE $$WM_CREATE
			RETURN MainOnCreate(hWnd)
			
		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
			hwndCtl    = lParam
			notifyCode = HIWORD(wParam)
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE id
						CASE $$RECORD_SNAP
							SELECT CASE AppState.status
								CASE $$STATUS_WAITING, $$STATUS_IDLING,$$STATUS_MONITERING
									AppState.noUseTimer = $$TRUE
									StartRecording ()
								CASE $$STATUS_RECORDING,$$STATUS_MOFOUND
									AppState.noUseTimer = $$FALSE
									StopRecording ()
							END SELECT
						CASE $$RECORD_CONFIG
							StopEverything ()
							DialogBoxParamA (hInst, $$DLG_CONFIG, hWnd, &ConfigDlg(), 0)
							StartIdling()
						CASE $$REVIEW_BT_SAVEPIC
							SendMessageA (GuiInfo.hView, $$VWNM_SAVEPIC, 0, 0)
'						CASE $$REVIEW_BT_SAVEMOV
						CASE $$REVIEW_BT_DELETE
							SendMessageA (GuiInfo.hView, $$VWNM_UNLOAD, 0, 0)
							SendMessageA (GuiInfo.hList, $$THLM_DELCLIP, 0, 0)
					END SELECT
			END SELECT
			
		CASE $$THLN_CLIPSEL
			SendMessageA (GuiInfo.hView, $$VWNM_UNLOAD, 0, 0)
			SendMessageA (GuiInfo.hView, $$VWNM_LOAD, wParam, 0)
			
		CASE $$WM_CLOSE
			StopEverything ()
			DestroyWindow (hWnd)
			
		CASE $$WM_DESTROY :
			StopEverything ()
			DestroyWindow (GuiInfo.hView)
			DestroyWindow (GuiInfo.hList)
			PostQuitMessage(0)
			
		CASE $$WM_NOTIFY :
			idTT = wParam
			GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)			' get info from first NMHDR struct
			SELECT CASE code :
				CASE $$TTN_GETDISPINFO
					pStruc = &nmttdi
					XLONGAT(&&nmttdi) = lParam
					
					IF nmttdi.hdr.idFrom = GuiInfo.hSnapButton THEN
						IF AppState.status = $$STATUS_RECORDING||AppState.status = $$STATUS_MOFOUND THEN 
							nmttdi.lpszText = &"Stop recording now"
						ELSE
							nmttdi.lpszText = &"Start recording now"
						END IF
					ELSE
						tttAddr = lParam
						SELECT CASE idTT																		' selection on button id
							CASE $$PAGE_RECORD:	SetToolTipText (tttAddr, "Use to record footage")
							CASE $$PAGE_REVIEW:	SetToolTipText (tttAddr, "Use to view, copy and delete footage")
						END SELECT
					END IF
					
					XLONGAT(&&nmttdi) = pStruc
					
				CASE $$TCN_SELCHANGE :
					GuiInfo.currentTab = SendMessageA (hwndFrom, $$TCM_GETCURSEL, 0, 0)		' get current tab selection
					SELECT CASE GuiInfo.currentTab
						CASE $$PAGE_RECORD
							StopEverything ()
							SendMessageA (GuiInfo.hList, $$THLM_BUTTONSUP, 0, 0) 
							StartIdling()
							showHidePage ($$PAGE_REVIEW, $$FALSE)
							showHidePage ($$PAGE_RECORD, $$TRUE)
						CASE $$PAGE_REVIEW
							StopEverything ()
							SetStatus($$STATUS_REVIEW)
							showHidePage ($$PAGE_RECORD, $$FALSE)
							showHidePage ($$PAGE_REVIEW, $$TRUE)
					END SELECT
			END SELECT
			
		CASE $$WM_TIMER
			'check the time
			GetLocalTime (&sysTime)
			
			nowTime = ((sysTime.wHour AND 0x00FF)<<16)|((sysTime.wMinute AND 0x00FF)<<8)|(sysTime.wSecond AND 0x00FF)
			
			IF !AppState.useTimer || (nowTime >= AppState.timerStart && nowTime < AppState.timerEnd) THEN
				'start the appropriate callback
				SELECT CASE AppState.moniterMode
					CASE $$MONMODE_TIMELAPSE
						IF AppState.useTimer THEN
							StopEverything ()
							StartRecording ()
						END IF
					CASE $$MONMODE_MODETECT
						StopEverything ()
						StartMotion ()
				END SELECT
			END IF
			
		CASE $$WM_GETMINMAXINFO
			'fill out the rect
			GetWindowRect (GuiInfo.hStatusBar, &rect2)
			rect.top = 0
			rect.left = 0
			rect.right = MAX(GuiInfo.capWidth, GuiInfo.viewWidth)+124
			rect.bottom = MAX(GuiInfo.capHeight, GuiInfo.viewHeight)+84+rect2.bottom-rect2.top
			
			'and enlarge as required
			SendMessageA (GuiInfo.hTabs, $$TCM_ADJUSTRECT, $$TRUE, &rect)
			AdjustWindowRect (&rect, $$WS_OVERLAPPEDWINDOW, $$FALSE)
			
			pStruc = &mmi
			XLONGAT(&&mmi) = lParam
			mmi.ptMinTrackSize.x = rect.right-rect.left
			mmi.ptMinTrackSize.y = rect.bottom-rect.top
			XLONGAT(&&mmi) = pStruc
			
		CASE $$WM_SIZE
			w = LOWORD (lParam)
			h = HIWORD (lParam)
			sizeType = wParam
			
			IF sizeType = $$SIZE_MINIMIZED THEN
				RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
			END IF
			
			sizeMainControls (hWnd, w, h)
			
		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
	END SELECT
END FUNCTION
'
' ###########################
' #####  ThumbListProc  #####
' ###########################
' This window is a list of every clip currently available
'	messages:
' $$THLM_BUTTONSUP
' $$THLM_ADDCLIP, hBMP, iFile
' $$THLM_SELECTFILE, iFile
' $$THLM_DELCLIP
'  returns $$TRUE on success or $$FALSE if no buttons are selected
' notifications:
' $$THLN_CLIPSEL, iFile
FUNCTION ThumbListProc (hWnd, msg, wParam, lParam)
	SHARED	hInst
	SHARED	GUIINFO	GuiInfo
	SHARED	APPSTATE	AppState
	SHARED	STRING	saveLocation
	
	STATIC	bCount
	STATIC	THUMBINFO	buttons[]
	STATIC	scrollUnit
	STATIC	STRING	toolTipText
	STATIC SCROLLINFO	scrollInfo
	
	FILENAME	fileInfo
	
	THUMBINFO button
	TOOLINFO	tool
	
	SYSTEMTIME	sysTime
	PAINTSTRUCT ps
	RECT rect
	
	NMTTDISPINFO nmttdi
	
	SELECT CASE msg
		
		CASE $$WM_CREATE
			DIM buttons[7]
			
			'make the tooltips
			GuiInfo.hToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hWnd, 0, hInst, 0)
			SetWindowPos(GuiInfo.hToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			
			GetClientRect (hWnd, &rect)
			
			scrollInfo.cbSize = SIZE(SCROLLINFO)
			scrollInfo.fMask = $$SIF_ALL
			scrollInfo.nMin = 0
			scrollInfo.nMax = 0
			scrollInfo.nPage = rect.bottom-rect.top
			scrollInfo.nPos = 0
			SetScrollInfo (hWnd, $$SB_VERT, &scrollInfo, $$TRUE)
			
			GetClientRect (hWnd, &rect)
			scrollUnit = (rect.right-rect.left)\6
		
		CASE $$WM_DESTROY
			'deallocate all resources
			FOR i = 0 TO bCount-1
				DestroyWindow (buttons[i].hButton)
				DeleteObject (buttons[i].hBMP)
			NEXT

		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
			hwndCtl    = lParam
			notifyCode = HIWORD(wParam)
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					'steal focus
					SetFocus (hWnd)
					'get the button's index
					id = id-20100
					'if its already active we're done, otherwise...
					IFF buttons[id].active THEN
						'activate the button
						FOR i = 0 TO bCount-1
							buttons[i].active = $$FALSE
						NEXT
						buttons[id].active = $$TRUE
						'notify the main window we have a clip to play
						PostMessageA (#winMain, $$THLN_CLIPSEL, buttons[id].iFile, 0)
					END IF
			END SELECT
			
		CASE $$WM_NOTIFY
			idTT = wParam
			GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)			' get info from first NMHDR struct
			SELECT CASE code
				CASE $$TTN_GETDISPINFO
					pStruc = &nmttdi
					XLONGAT(&&nmttdi) = lParam
					
					SendMessageA(hwndFrom, $$TTM_SETMAXTIPWIDTH, 0, 300)
					
					'generate the tooltip text
					IF fileIndex_Get (buttons[nmttdi.lParam].iFile, @fileInfo) THEN
						FileTimeToSystemTime (&fileInfo.fileTime, &sysTime)
						
						toolTipText = "Date: "
						cc = GetDateFormatA ($$LOCALE_USER_DEFAULT, $$DATE_LONGDATE, &sysTime, 0, 0, 0)
						buffer$ = NULL$(cc)
						GetDateFormatA ($$LOCALE_USER_DEFAULT, $$DATE_LONGDATE, &sysTime, 0, &buffer$, cc)
						
						toolTipText = toolTipText+CSTRING$(&buffer$)+"\r\nTime: "
						cc = GetTimeFormatA ($$LOCALE_USER_DEFAULT, 0, &sysTime, 0, 0, 0)
						buffer$ = NULL$(cc)
						GetTimeFormatA ($$LOCALE_USER_DEFAULT, 0, &sysTime, 0, &buffer$, cc)
						toolTipText = toolTipText+CSTRING$(&buffer$)
					ELSE
						toolTipText = "error"
					END IF
					
					nmttdi.lpszText = &toolTipText
					
					XLONGAT(&&nmttdi) = pStruc
			END SELECT
		
		CASE $$THLM_BUTTONSUP
			'lift up the buttons
			FOR i = 0 TO bCount-1
				SendMessageA (buttons[i].hButton, $$BM_SETCHECK, $$BST_UNCHECKED, 0)
				buttons[i].active = $$FALSE
			NEXT
			
		CASE $$THLM_ADDCLIP
			'make sure there's enough memmory
			IF bCount > UBOUND(buttons[]) THEN REDIM buttons[((UBOUND(buttons[])+1)<<1)-1]
			
			buttons[bCount].hBMP = wParam
			buttons[bCount].iFile = lParam
			buttons[bCount].active = $$FALSE
			
			GetClientRect (hWnd, &rect)
			
			'make the button
			buttons[bCount].hButton = NewChild ("Button", "", $$BS_AUTORADIOBUTTON|$$BS_PUSHLIKE|$$BS_BITMAP|$$WS_TABSTOP, rect.left, _
			(bCount*(rect.right-rect.left))+rect.top-scrollInfo.nPos,	rect.right-rect.left, rect.right-rect.left, hWnd, bCount+20100, 0)
			
			'now set the image
			SendMessageA (buttons[bCount].hButton, $$BM_SETIMAGE, $$IMAGE_BITMAP, buttons[bCount].hBMP)
			
			'and the tooltip
			tool.cbSize = SIZE(TOOLINFO)
			tool.uFlags = $$TTF_SUBCLASS|$$TTF_IDISHWND
			tool.hwnd = hWnd
			tool.uId = buttons[bCount].hButton
			tool.hinst = hInst
			tool.lpszText = $$LPSTR_TEXTCALLBACK
			tool.lParam = bCount
			SendMessageA (GuiInfo.hToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			'inc bCount
			INC bCount
			
			'and finnaly, update the scrollbar
			scrollInfo.cbSize = SIZE(SCROLLINFO)
			scrollInfo.fMask = $$SIF_ALL
			scrollInfo.nMin = 0
			scrollInfo.nMax = bCount*(rect.right-rect.left)
			scrollInfo.nPage = rect.bottom-rect.top
			SetScrollInfo (hWnd, $$SB_VERT, &scrollInfo, $$TRUE)
			
		CASE $$THLM_SELECTFILE
			'locate the correct button
			IF bCount-1 > UBOUND(buttons[]) THEN
				MessageBoxA (0, &"bCount beyond UBOUND(buttons[])", &"error", $$MB_OK|$$MB_ICONERROR)
				QUIT(0)
			END IF
			id = -1
			FOR i = 0 TO bCount-1
				IF buttons[i].iFile = wParam THEN
					id = i
					EXIT FOR
				END IF
			NEXT
			
			IF id = -1 THEN
				RETURN $$FALSE
			ELSE
				buttons[i].active = $$TRUE
				RETURN $$TRUE
			END IF
			
		CASE $$THLM_DELCLIP
			IF bCount-1 > UBOUND(buttons[]) THEN
				MessageBoxA (0, &"bCount beyond UBOUND(buttons[])", &"error", $$MB_OK|$$MB_ICONERROR)
				QUIT(0)
			END IF
			'find the button
			id = -1
			FOR i = 0 TO bCount-1
				IF buttons[i].active THEN
					id = i
					EXIT FOR
				END IF
			NEXT
			IF id = -1 THEN RETURN $$FALSE
			
			'remove the button
			DestroyWindow (buttons[id].hButton)
			DeleteObject (buttons[id].hBMP)
			
			'delete the file
			fileIndex_Get (buttons[id].iFile, @fileInfo)
			XstDeleteFile (saveLocation+"\\"+fileInfo.name+".dat")
			AppState.usedSpace = AppState.usedSpace - fileInfo.size
			
			'now fix the index
			fileIndex_Delete (buttons[id].iFile)
			WriteIndex ()
			
			'delete the tooltips
			tool.cbSize = SIZE(TOOLINFO)
			tool.hwnd = hWnd
			FOR i = 0 TO bCount-1
				tool.uId = buttons[i].hButton
				SendMessageA (GuiInfo.hToolTips, $$TTM_DELTOOL, 0, &tool)
			NEXT
			
			'update the structure
			FOR i = id TO bCount-2
				buttons[i] = buttons[i+1]
			NEXT
			DEC bCount
			
			'now reset the ids and rebuild the tooltips
			tool.cbSize = SIZE(TOOLINFO)
			tool.uFlags = $$TTF_SUBCLASS|$$TTF_IDISHWND
			tool.hwnd = hWnd
			tool.hinst = hInst
			tool.lpszText = $$LPSTR_TEXTCALLBACK
			
			FOR i = 0 TO bCount-1
				SetWindowLongA (buttons[i].hButton, $$GWL_ID, 20100+i)
				tool.uId = buttons[i].hButton
				tool.lParam = i
				SendMessageA (GuiInfo.hToolTips, $$TTM_ADDTOOL, 0, &tool)
			NEXT
			
			'redraw the buttons
			GetClientRect (hWnd, &rect)
			w = rect.right-rect.left
			
			'and update the scrollbars
			scrollInfo.cbSize = SIZE(SCROLLINFO)
			scrollInfo.fMask = $$SIF_ALL
			scrollInfo.nMin = 0
			scrollInfo.nMax = bCount*w
			scrollInfo.nPage = rect.bottom-rect.top
			IF scrollInfo.nPage >= scrollInfo.nMax THEN
				scrollInfo.nPos = 0
			ELSE
				IF scrollInfo.nPos > scrollInfo.nMax-scrollInfo.nPage THEN scrollInfo.nPos = scrollInfo.nMax-scrollInfo.nPage+1
				IF scrollInfo.nPos < 0 THEN scrollPos = 0
			END IF
			SetScrollInfo (hWnd, $$SB_VERT, &scrollInfo, $$TRUE)
			
			GOSUB UpdateButtons
			
			'and we're done
			RETURN $$TRUE
		CASE $$WM_SIZE
			w = LOWORD (lParam)
			h = HIWORD (lParam)
			sizeType = wParam
			
			scrollInfo.cbSize = SIZE(SCROLLINFO)
			scrollInfo.fMask = $$SIF_ALL
			scrollInfo.nMin = 0
			scrollInfo.nMax = bCount*w
			scrollInfo.nPage = h
			SetScrollInfo (hWnd, $$SB_VERT, &scrollInfo, $$TRUE)
			
		CASE $$WM_KEYDOWN
			scrollNotify = -1
			SELECT CASE wParam
				CASE $$VK_UP
					scrollNotify = $$SB_LINEUP
				CASE $$VK_PRIOR
					scrollNotify = $$SB_PAGEUP
				CASE $$VK_NEXT
					scrollNotify = $$SB_PAGEDOWN
				CASE $$VK_DOWN
					scrollNotify = $$SB_LINEDOWN
				CASE $$VK_HOME
					scrollNotify = $$SB_TOP
				CASE $$VK_END
					scrollNotify = $$SB_BOTTOM
			END SELECT
			IF scrollNotify != -1 THEN SendMessageA (hWnd, $$WM_VSCROLL, 0|(scrollNotify AND 0x0000FFFF), 0)
			
		CASE $$WM_MOUSEWHEEL
			delta% = HIWORD(wParam)
			IF delta% > 0 THEN 
				SendMessageA (hWnd, $$WM_VSCROLL, $$SB_LINEUP, 0)
			ELSE
				IF delta% < 0 THEN SendMessageA (hWnd, $$WM_VSCROLL, $$SB_LINEDOWN, 0)
			END IF
			
		CASE $$WM_VSCROLL
			sbval = LOWORD(wParam)
			pos = HIWORD(wParam)
			IF scrollInfo.nPage <= scrollInfo.nMax THEN
				SELECT CASE sbval
					CASE $$SB_TOP
						scrollInfo.nPos = 0
					CASE $$SB_BOTTOM
						scrollInfo.nPos = scrollInfo.nMax - scrollInfo.nPage
					CASE $$SB_LINEUP
						IF scrollInfo.nPos < scrollUnit THEN scrollInfo.nPos = 0 ELSE scrollInfo.nPos = scrollInfo.nPos - scrollUnit
					CASE $$SB_LINEDOWN
						IF scrollInfo.nPos+scrollUnit >  (scrollInfo.nMax-scrollInfo.nPage+1) THEN scrollInfo.nPos = scrollInfo.nMax-scrollInfo.nPage+1 ELSE scrollInfo.nPos = scrollInfo.nPos + scrollUnit
					CASE $$SB_PAGEUP
						IF scrollInfo.nPos < scrollInfo.nPage THEN scrollInfo.nPos = 0 ELSE scrollInfo.nPos = scrollInfo.nPos - scrollInfo.nPage
					CASE $$SB_PAGEDOWN
						IF scrollInfo.nPos+scrollInfo.nPage > (scrollInfo.nMax-scrollInfo.nPage+1) THEN scrollInfo.nPos = scrollInfo.nMax-scrollInfo.nPage+1 ELSE scrollInfo.nPos = scrollInfo.nPos + scrollInfo.nPage
					CASE $$SB_THUMBTRACK
						scrollInfo.nPos = pos
				END SELECT
				'now move the buttons
				GetClientRect (hWnd, &rect)
				w = rect.right-rect.left
				
				GOSUB UpdateButtons
				
				SetScrollInfo (hWnd, $$SB_VERT, &scrollInfo, $$TRUE)
			END IF
		CASE ELSE
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT
	RETURN 0
	
	SUB UpdateButtons
		'use deferwindowpos to move all windows simulteaneously
		hDWP = BeginDeferWindowPos (bCount-1)
		FOR i = 0 TO bCount-1
			hDWP = DeferWindowPos (hDWP, buttons[i].hButton, 0, rect.left, (w*i)-scrollInfo.nPos+rect.top, w, w, $$SWP_NOACTIVATE|$$SWP_NOOWNERZORDER|$$SWP_NOZORDER)
		NEXT
		EndDeferWindowPos (hDWP)
	END SUB

END FUNCTION
'
' ######################
' #####  ViewProc  #####
' ######################
' This window is used to view clips
' messages:
'VWNM_SAVEPIC
'VWNM_SAVEMOV
'VWNM_LOAD, wParam:iFile to load
'VWNM_UNLOAD
FUNCTION ViewProc (hWnd, msg, wParam, lParam)
	SHARED	hInst
	SHARED	APPSTATE	AppState
	SHARED	GUIINFO	GuiInfo
	SHARED	STRING	saveLocation

	TOOLINFO	tool	
	PAINTSTRUCT ps
	RECT rect
	SIZEAPI	textSize
	NMTTDISPINFO nmttdi
	
	FILENAME	fileInfo
	BITMAPFILEHEADER	bmfh
	
	SYSTEMTIME	sysTime
	
	STATIC	POINTAPI	vidPos
	STATIC	BITMAPINFOHEADER	bmih
	
	SELECT CASE msg
		
		CASE $$WM_CREATE
			'build the interface
			'first, the tooltips
			GuiInfo.hViewToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hWnd, 0, hInst, 0)
			SetWindowPos(GuiInfo.hViewToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			SendMessageA(GuiInfo.hViewToolTips, $$TTM_SETMAXTIPWIDTH, 0, 300)
			tool.cbSize = SIZE(TOOLINFO)
			tool.uFlags = $$TTF_SUBCLASS|$$TTF_IDISHWND
			tool.hwnd = hWnd
			tool.hinst = hInst
			
			GetClientRect (hWnd, &rect)
			
			'first, the position tracker
			GuiInfo.hPosTracker = NewChild ($$TRACKBAR_CLASS, "position", $$WS_TABSTOP|$$TBS_AUTOTICKS, _
			rect.left+24, rect.bottom-48, rect.right-rect.left-48, 24, hWnd, $$VIEW_TRKBR_POS, 0)
			SendMessageA (GuiInfo.hPosTracker, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			
			tool.uId = GuiInfo.hPosTracker
			tool.lpszText = &"Current position of the player\r\n Adjust the slider to change"
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			'the rest have to fit into the next line evenly
			cW = (rect.right-rect.left)\4
			cW# = (DOUBLE(rect.right)-DOUBLE(rect.left))/4.0
			
			GuiInfo.hPrevButton = NewChild ("Button", "prev", $$BS_PUSHBUTTON|$$WS_TABSTOP, 0, rect.bottom-24, cW, 24, hWnd, $$VIEW_BT_PREV, 0)
			GuiInfo.hPlayButton = NewChild ("Button", "play", $$BS_PUSHBUTTON|$$WS_TABSTOP, INT(cW#), rect.bottom-24, cW, 24, hWnd, $$VIEW_BT_PLAY, 0)
			GuiInfo.hNextButton = NewChild ("Button", "next", $$BS_PUSHBUTTON|$$WS_TABSTOP, INT(cW#*3.0), rect.bottom-24, cW, 24, hWnd, $$VIEW_BT_NEXT, 0)
			GuiInfo.hRewind = NewChild ("Button", "|<", $$BS_PUSHBUTTON|$$WS_TABSTOP, rect.left, rect.bottom-48, 24, 24, hWnd, $$VIEW_BT_REWIND, 0)
			GuiInfo.hFastFoward = NewChild ("Button", ">|", $$BS_PUSHBUTTON|$$WS_TABSTOP, rect.right-24, rect.bottom-48, 24, 24, hWnd, $$VIEW_BT_FF, 0)
			
			GuiInfo.hSpeedTracker = NewChild ($$TRACKBAR_CLASS, "speed", $$WS_TABSTOP, _
			INT(cW#*2.0), rect.bottom-24, cW, 24, hWnd, $$VIEW_TRKBR_SPEED, 0)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETRANGE, $$FALSE, 0x00180000)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETTIC, 0, 0)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETTIC, 0, 4)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETTIC, 0, 9)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETTIC, 0, 14)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETTIC, 0, 19)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETTIC, 0, 24)
			SendMessageA (GuiInfo.hSpeedTracker, $$TBM_SETPOS, $$TRUE, 9)
			
			SendMessageA (GuiInfo.hPrevButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			SendMessageA (GuiInfo.hPlayButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			SendMessageA (GuiInfo.hNextButton, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			SendMessageA (GuiInfo.hRewind, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			SendMessageA (GuiInfo.hFastFoward, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			SendMessageA (GuiInfo.hSpeedTracker, $$WM_SETFONT, GetStockObject ($$DEFAULT_GUI_FONT), $$TRUE)
			
			tool.uId = GuiInfo.hPrevButton
			tool.lpszText = &"Go back a frame"
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			tool.uId = GuiInfo.hPlayButton
			tool.lpszText = $$LPSTR_TEXTCALLBACK
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			tool.uId = GuiInfo.hNextButton
			tool.lpszText = &"Go to the next frame"
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			tool.uId = GuiInfo.hSpeedTracker
			tool.lpszText = &"Current playing speed\r\nAdjust the slider to change"
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			tool.uId = GuiInfo.hRewind
			tool.lpszText = &"Jump to the beginning"
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			tool.uId = GuiInfo.hFastFoward
			tool.lpszText = &"Jump to the end"
			SendMessageA (GuiInfo.hViewToolTips, $$TTM_ADDTOOL, 0, &tool)
			
			'disable all these controls as we don't need them
			EnableWindow (GuiInfo.hPosTracker, $$FALSE)
			EnableWindow (GuiInfo.hPrevButton, $$FALSE)
			EnableWindow (GuiInfo.hPlayButton, $$FALSE)
			EnableWindow (GuiInfo.hNextButton, $$FALSE)
			EnableWindow (GuiInfo.hRewind, $$FALSE)
			EnableWindow (GuiInfo.hFastFoward, $$FALSE)
			EnableWindow (GuiInfo.hSpeedTracker, $$FALSE)
			'include the save and delete buttons
			EnableWindow (GuiInfo.hSavePicButton, $$FALSE)
			EnableWindow (GuiInfo.hDeleteButton, $$FALSE)
			
			'and get the drawDIBDC
			GuiInfo.hDDdc = DrawDibOpen ()
		
		CASE $$WM_DESTROY
			DrawDibClose(GuiInfo.hDDdc)
			
		CASE $$WM_NOTIFY
			idTT = wParam
			GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)			' get info from first NMHDR struct
			SELECT CASE code
				CASE $$TTN_GETDISPINFO
					pStruc = &nmttdi
					XLONGAT(&&nmttdi) = lParam
					
					IF AppState.status = $$STATUS_PLAYING THEN nmttdi.lpszText = &"Stop playing now" ELSE nmttdi.lpszText = &"Play footage now"
					
					XLONGAT(&&nmttdi) = pStruc
			END SELECT
			
		CASE $$WM_COMMAND
			id         = LOWORD(wParam)
			hwndCtl    = lParam
			notifyCode = HIWORD(wParam)
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE id
						CASE $$VIEW_BT_REWIND
							IF AppState.status = $$STATUS_PLAYING THEN GOSUB StopPlaying
							AppState.currentFrame = 0
							SendMessageA (GuiInfo.hPosTracker, $$TBM_SETPOS, $$TRUE, AppState.currentFrame)
							EnableWindow (GuiInfo.hNextButton, $$TRUE)
							EnableWindow (GuiInfo.hFastFoward, $$TRUE)
							EnableWindow (GuiInfo.hPrevButton, $$FALSE)
							EnableWindow (GuiInfo.hRewind, $$FALSE)
							GOSUB DrawFrame
						CASE $$VIEW_BT_FF
							IF AppState.status = $$STATUS_PLAYING THEN GOSUB StopPlaying
							AppState.currentFrame = AppState.totalFrames - 1
							SendMessageA (GuiInfo.hPosTracker, $$TBM_SETPOS, $$TRUE, AppState.currentFrame)
							EnableWindow (GuiInfo.hNextButton, $$FALSE)
							EnableWindow (GuiInfo.hFastFoward, $$FALSE)
							EnableWindow (GuiInfo.hPrevButton, $$TRUE)
							EnableWindow (GuiInfo.hRewind, $$TRUE)
							GOSUB DrawFrame
						CASE $$VIEW_BT_PREV
							'if this was the last frame, enable next button
							IF AppState.currentFrame + 1 = AppState.totalFrames THEN
								EnableWindow (GuiInfo.hNextButton, $$TRUE)
								EnableWindow (GuiInfo.hFastFoward, $$TRUE)
							END IF
							DEC AppState.currentFrame
							
							'disable the button if this is the first frame
							IF AppState.currentFrame = 0 THEN
								EnableWindow (hwndCtl, $$FALSE)
								EnableWindow (GuiInfo.hRewind, $$FALSE)
							END IF
							
							'update the position tracker
							SendMessageA (GuiInfo.hPosTracker, $$TBM_SETPOS, $$TRUE, AppState.currentFrame)
							
							GOSUB DrawFrame
						CASE $$VIEW_BT_PLAY
							'check the state
							IF AppState.status = $$STATUS_PLAYING THEN
								GOSUB StopPlaying
							ELSE
								IF AppState.currentFrame + 1 >= AppState.totalFrames THEN AppState.currentFrame = 0
								SetWindowTextA (hwndCtl, &"Stop")
								SetStatus($$STATUS_PLAYING)
								EnableWindow (GuiInfo.hPosTracker, $$FALSE)
								EnableWindow (GuiInfo.hNextButton, $$FALSE)
								EnableWindow (GuiInfo.hPrevButton, $$FALSE)
								EnableWindow (GuiInfo.hRewind, $$TRUE)
								EnableWindow (GuiInfo.hFastFoward, $$TRUE)
								SetTimer (hWnd, $$VIEW_TIMER, 1000\(SendMessageA (GuiInfo.hSpeedTracker, $$TBM_GETPOS, 0, 0)+1), 0)
							END IF
						CASE $$VIEW_BT_NEXT
							'if this was the first frame, enable prev button
							IF AppState.currentFrame = 0 THEN
								EnableWindow (GuiInfo.hPrevButton, $$TRUE)
								EnableWindow (GuiInfo.hRewind, $$TRUE)
							END IF
							INC AppState.currentFrame
							'disable the button if this is the last frame
							IF AppState.currentFrame + 1 = AppState.totalFrames THEN
								EnableWindow (hwndCtl, $$FALSE)
								EnableWindow (GuiInfo.hFastFoward, $$FALSE)
							END IF
							
							'update the position tracker
							SendMessageA (GuiInfo.hPosTracker, $$TBM_SETPOS, $$TRUE, AppState.currentFrame)
							
							GOSUB DrawFrame
					END SELECT
			END SELECT
			
		CASE $$VWNM_SAVEPIC
			'first up, get a file name from the user
			fileName$ = GetSaveName$ ("Bitmap Files\0*.BMP\0\0", "bmp", &saveExtHook (), $$DLG_SAVEEXT)
			
			IF fileName$ = "" THEN RETURN $$FALSE
			
			'write the new dateTime stamp state into the registry
			IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "dateStamp", AppState.dateStamp) THEN QUIT(0)
			
			'copy the bitmap
			saveBuffer$ = NULL$(AppState.cbFrame)
			RtlMoveMemory (&saveBuffer$, getFrame (AppState.currentFrame), AppState.cbFrame)
			
			IF AppState.dateStamp
				'we need to date-stamp the bitmap
				fileIndex_Get (AppState.fileId, @fileInfo)
				DateStamp (fileInfo.fileTime, &saveBuffer$, bmih.biWidth, fileInfo.frameInt*AppState.currentFrame)
			END IF
			
			bmfh.bfType = 0x4D42
			bmfh.bfSize = SIZE(BITMAPFILEHEADER)+SIZE(BITMAPINFOHEADER)+AppState.cbFrame
			bmfh.bfOffBits = SIZE(BITMAPFILEHEADER)+SIZE(BITMAPINFOHEADER)
			'ok, now save the image
			fileNum = OPEN (fileName$, $$RWNEW)
				WRITE[fileNum], bmfh
				WRITE[fileNum], bmih
				WRITE[fileNum], saveBuffer$
			CLOSE(fileNum)
			
'		CASE $$VWNM_SAVEMOV
'			
'			
		CASE $$VWNM_LOAD
			'load up a file
			AppState.fileId = wParam
			IFF fileIndex_Get (AppState.fileId, @fileInfo) THEN RETURN $$FALSE
			
			
			AppState.totalFrames = fileInfo.frameCount
			
			'AppState.fileNum  = OPEN (saveLocation+"\\"+fileInfo.name+".dat", $$RD)
			'IF AppState.fileNum = -1 THEN RETURN $$FALSE
			fullFileName$ = saveLocation+"\\"+fileInfo.name+".dat"
			AppState.fileNum = CreateFileA (&fullFileName$, $$GENERIC_READ, 0, 0, $$OPEN_EXISTING, $$FILE_ATTRIBUTE_NORMAL, 0)
			IF AppState.fileNum = $$INVALID_HANDLE_VALUE THEN RETURN $$FALSE
			
			'get the header
			'READ[AppState.fileNum], bmih
			ReadFile (AppState.fileNum, &bmih, SIZE(BITMAPINFOHEADER), &bytesRead, 0)
			
			'now calculate the frame buffer size
			AppState.cbFrame = bmih.biWidth*bmih.biHeight*(bmih.biBitCount>>3)
			
			
			'resize the player window
			IF bmih.biWidth > GuiInfo.viewWidth THEN GuiInfo.viewWidth = bmih.biWidth
			IF bmih.biHeight > GuiInfo.viewHeight THEN GuiInfo.viewHeight = bmih.biHeight
			vidPos.x = (GuiInfo.viewWidth-bmih.biWidth)\2
			vidPos.y = (GuiInfo.viewHeight-bmih.biHeight)\2
			updatePositions ()
			
			
			'set the pos tracker range
			SendMessageA (GuiInfo.hPosTracker, $$TBM_SETRANGE, $$FALSE, ((AppState.totalFrames-1) AND 0x0000FFFF)<<16)
			IF AppState.totalFrames > 0 THEN 
				IF (GuiInfo.viewWidth-48)\AppState.totalFrames < 4 THEN
					SendMessageA (GuiInfo.hPosTracker, $$TBM_SETTICFREQ, (4.0*DOUBLE(AppState.totalFrames))/(DOUBLE(GuiInfo.viewWidth)-48.0), 0)
				ELSE
					SendMessageA (GuiInfo.hPosTracker, $$TBM_SETTICFREQ, 1, 0)
				END IF
			ELSE
				SendMessageA (GuiInfo.hPosTracker, $$TBM_SETTICFREQ, 1, 0)
			END IF
			
			
			'enable the controls
			EnableWindow (GuiInfo.hPosTracker, $$TRUE)
			EnableWindow (GuiInfo.hPlayButton, $$TRUE)
			EnableWindow (GuiInfo.hNextButton, $$TRUE)
			EnableWindow (GuiInfo.hFastFoward, $$TRUE)
			EnableWindow (GuiInfo.hSpeedTracker, $$TRUE)
			'include the save and delete buttons
			EnableWindow (GuiInfo.hSavePicButton, $$TRUE)
			EnableWindow (GuiInfo.hDeleteButton, $$TRUE)
			
			
			'prepare the current frame
			AppState.currentFrame = 0
			currentFrameBuffer = initReadBuffer (AppState.cbFrame, AppState.fileNum, 10, AppState.totalFrames)
			SetStatus($$STATUS_STOPPED)
			
			'redraw the window
			GetClientRect (hWnd, &rect)
			InvalidateRect (hWnd, &rect, $$FALSE)
			
			'and we're done
			RETURN $$TRUE
			
		CASE $$VWNM_UNLOAD
			'stop the timer if it's running
			KillTimer (hWnd, $$VIEW_TIMER)
			
			'fix up the state
			SetStatus($$STATUS_REVIEW)
			
			'deallocate the buffer
			freeReadBuffer ()
			
			'close the file
			FlushFileBuffers (AppState.fileNum)
			CloseHandle (AppState.fileNum)
			
			'and disable all the controls
			SendMessageA (GuiInfo.hPosTracker, $$TBM_SETPOS, $$TRUE, 0)
			EnableWindow (GuiInfo.hPosTracker, $$FALSE)
			EnableWindow (GuiInfo.hPrevButton, $$FALSE)
			EnableWindow (GuiInfo.hPlayButton, $$FALSE)
			EnableWindow (GuiInfo.hNextButton, $$FALSE)
			EnableWindow (GuiInfo.hRewind, $$FALSE)
			EnableWindow (GuiInfo.hFastFoward, $$FALSE)
			EnableWindow (GuiInfo.hSpeedTracker, $$FALSE)
			'include the save and delete buttons
			EnableWindow (GuiInfo.hSavePicButton, $$FALSE)
			EnableWindow (GuiInfo.hDeleteButton, $$FALSE)
			
			'finnaly, redraw the window
			GetClientRect (hWnd, &rect)
			InvalidateRect (hWnd, &rect, $$TRUE)
			
		CASE $$WM_HSCROLL
			'a trackbar was moved
			code = LOWORD(wParam)
			pos = HIWORD(wParam)
			SELECT CASE lParam
				CASE GuiInfo.hPosTracker
					IF code = $$TB_ENDTRACK THEN
						IF AppState.currentFrame < AppState.totalFrames - 1 THEN
							EnableWindow (GuiInfo.hNextButton, $$TRUE)
							EnableWindow (GuiInfo.hFastFoward, $$TRUE)
						ELSE
							EnableWindow (GuiInfo.hNextButton, $$FALSE)
							EnableWindow (GuiInfo.hFastFoward, $$FALSE)
						END IF
						IF AppState.currentFrame > 0 THEN
							EnableWindow (GuiInfo.hPrevButton, $$TRUE)
							EnableWindow (GuiInfo.hRewind, $$TRUE)
						ELSE
							EnableWindow (GuiInfo.hPrevButton, $$FALSE)
							EnableWindow (GuiInfo.hRewind, $$FALSE)
						END IF
					ELSE
						AppState.currentFrame = SendMessageA (GuiInfo.hPosTracker, $$TBM_GETPOS, 0, 0)
						GOSUB DrawFrame
					END IF
				CASE GuiInfo.hSpeedTracker
					IF AppState.status = $$STATUS_PLAYING THEN
						KillTimer (hWnd, $$VIEW_TIMER)
						SetTimer (hWnd, $$VIEW_TIMER, 1000\(SendMessageA (GuiInfo.hSpeedTracker, $$TBM_GETPOS, 0, 0)+1), 0)
					END IF
			END SELECT
			
		CASE $$WM_TIMER
			INC AppState.currentFrame
			'if this is the last frame, stop
			
			IF AppState.currentFrame + 1 >= AppState.totalFrames THEN GOSUB StopPlaying
			
			'update the position tracker
			SendMessageA (GuiInfo.hPosTracker, $$TBM_SETPOS, $$TRUE, AppState.currentFrame)
			
			GOSUB DrawFrame
			
		CASE $$WM_PAINT
			'draw the current frame
			IF (AppState.status = $$STATUS_STOPPED)||(AppState.status = $$STATUS_PLAYING) THEN
				hdc = BeginPaint (hWnd, &ps)
					DrawDibDraw (GuiInfo.hDDdc, hdc, vidPos.x, vidPos.y, bmih.biWidth, bmih.biHeight, &bmih, _
					getFrame (AppState.currentFrame), 0, 0, bmih.biWidth, bmih.biHeight, wFlags)
				EndPaint (hWnd, &ps)
			ELSE
				RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
			END IF
			
		CASE $$WM_SIZE
			w = LOWORD (lParam)
			h = HIWORD (lParam)
			sizeType = wParam	
			
			GetClientRect (hWnd, &rect)
			cW = w\4
			cW# = DOUBLE(w)/4.0
			
			MoveWindow (GuiInfo.hPosTracker, rect.left+24, h-48, w-48, 24, $$FALSE)
			MoveWindow (GuiInfo.hPrevButton, 0, h-24, cW, 24, $$FALSE)
			MoveWindow (GuiInfo.hPlayButton, INT(cW#), h-24, cW, 24, $$FALSE)
			MoveWindow (GuiInfo.hNextButton, INT(cW#*3.0), h-24, cW, 24, $$FALSE)
			MoveWindow (GuiInfo.hRewind, rect.left, h-48, 24, 24, $$FALSE)
			MoveWindow (GuiInfo.hFastFoward, rect.right-24, h-48, 24, 24, $$FALSE)
			MoveWindow (GuiInfo.hSpeedTracker, INT(cW#*2.0), h-24, cW, 24, $$FALSE)
			
		CASE ELSE
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)
	END SELECT
	
	RETURN 0
	
	SUB StopPlaying
		KillTimer (hWnd, $$VIEW_TIMER)
		SetWindowTextA (GuiInfo.hPlayButton, &"Play")
		SetStatus($$STATUS_STOPPED)
		EnableWindow (GuiInfo.hPosTracker, $$TRUE)
		IF AppState.currentFrame < AppState.totalFrames - 1 THEN
			EnableWindow (GuiInfo.hNextButton, $$TRUE)
			EnableWindow (GuiInfo.hFastFoward, $$TRUE)
		ELSE
			EnableWindow (GuiInfo.hFastFoward, $$FALSE)
		END IF
		IF AppState.currentFrame > 0 THEN
			EnableWindow (GuiInfo.hPrevButton, $$TRUE)
			EnableWindow (GuiInfo.hRewind, $$TRUE)
		ELSE
			EnableWindow (GuiInfo.hRewind, $$FALSE)
		END IF
	END SUB
	
	SUB DrawFrame
		'draw the frame
		hdc = GetDC (hWnd)
			DrawDibDraw (GuiInfo.hDDdc, hdc, vidPos.x, vidPos.y, bmih.biWidth, bmih.biHeight, &bmih, _
			getFrame (AppState.currentFrame), 0, 0, bmih.biWidth, bmih.biHeight, wFlags)
		ReleaseDC (hWnd, hdc)
	END SUB

END FUNCTION
'
' ############################
' #####  ConfigTimerDlg  #####
' ############################
' This dialog box configures the timer
' Returns $$TRUE on OK, $$FALSE on CANCEL
FUNCTION ConfigTimerDlg (hDlg, msg, wParam, lParam)
	SHARED 		hInst
	SHARED	APPSTATE	AppState
	
	SYSTEMTIME time

	SELECT CASE msg
		CASE $$WM_INITDIALOG
			'initialise the controls
			hToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hDlg, 0, hInst, 0)
			SetWindowPos(hToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			SendMessageA(hToolTips, $$TTM_SETMAXTIPWIDTH, 0, 400)
			
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_TIMER_DTP_START), hToolTips, "This is the time at which time lapse recording or motion detection starts")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_TIMER_DTP_END), hToolTips, "This is the time at which time lapse recording or motion detection stops")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_TIMER_USE), hToolTips, _
			"When the timer is enabled, recording or motion monitering starts and ends at the specified times\r\n\r\nWhen the timer is disabled motion monitering runs continously.  If motion monitering is disabled, the program does nothing")
			
			IF AppState.useTimer THEN
				SendDlgItemMessageA (hDlg, $$DLG_TIMER_USE, $$BM_SETCHECK, $$BST_CHECKED, 0)
			ELSE
				SendDlgItemMessageA (hDlg, $$DLG_TIMER_USE, $$BM_SETCHECK, $$BST_UNCHECKED, 0)
			END IF
			
			'get the current values and write them in
			GetSystemTime (&time)
			time.wHour		= (AppState.timerStart AND 0x00FF0000)>>16
			time.wMinute	= (AppState.timerStart AND 0x0000FF00)>>8
			time.wSecond	= (AppState.timerStart AND 0x000000FF)
			SendDlgItemMessageA (hDlg, $$DLG_TIMER_DTP_START, $$DTM_SETSYSTEMTIME, $$GDT_VALID, &time)
			
			GetSystemTime (&time)
			time.wHour		= (AppState.timerEnd AND 0x00FF0000)>>16
			time.wMinute	= (AppState.timerEnd AND 0x0000FF00)>>8
			time.wSecond	= (AppState.timerEnd AND 0x000000FF)
			SendDlgItemMessageA (hDlg, $$DLG_TIMER_DTP_END, $$DTM_SETSYSTEMTIME, $$GDT_VALID, &time)
			
		CASE $$WM_COMMAND
			notifyCode = HIWORD(wParam)
			ID         = LOWORD(wParam)
			hwndCtl    = lParam
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE ID
						CASE $$IDOK
							'get the times
							IF SendDlgItemMessageA (hDlg, $$DLG_TIMER_DTP_START, $$DTM_GETSYSTEMTIME, 0, &time) = $$GDT_VALID THEN
								AppState.timerStart = ((time.wHour AND 0x00FF)<<16)|((time.wMinute AND 0x00FF)<<8)|(time.wSecond AND 0x00FF)
							ELSE
								MessageBoxA (hDlg, &"Bad start time", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							IF SendDlgItemMessageA (hDlg, $$DLG_TIMER_DTP_END, $$DTM_GETSYSTEMTIME, 0, &time) = $$GDT_VALID THEN
								AppState.timerEnd = ((time.wHour AND 0x00FF)<<16)|((time.wMinute AND 0x00FF)<<8)|(time.wSecond AND 0x00FF)
							ELSE
								MessageBoxA (hDlg, &"Bad end time", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							
							IF SendDlgItemMessageA (hDlg, $$DLG_TIMER_USE, $$BM_GETCHECK, 0, 0) = $$BST_CHECKED THEN
								AppState.useTimer = $$TRUE
							ELSE
								AppState.useTimer = $$FALSE
							END IF
							
							EndDialog (hDlg, $$TRUE)
						CASE $$IDCANCEL
							EndDialog (hDlg, $$FALSE)
					END SELECT
			END SELECT
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' ##############################
' #####  ConfigMoniterDlg  #####
' ##############################
' This dialog box configures the monitering system
' Returns $$TRUE on OK, $$FALSE on CANCEL
FUNCTION ConfigMoniterDlg (hDlg, msg, wParam, lParam)
	SHARED 		hInst
	SHARED	GUIINFO	GuiInfo
	SHARED	APPSTATE	AppState
	SHARED	STRING	saveLocation
	
	SELECT CASE msg
		CASE $$WM_INITDIALOG
			'initialise the controls
			hToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hDlg, 0, hInst, 0)
			SetWindowPos(hToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			SendMessageA(hToolTips, $$TTM_SETMAXTIPWIDTH, 0, 400)
			
			'radio buttons
			SELECT CASE AppState.moniterMode
				CASE $$MONMODE_TIMELAPSE
					CheckRadioButton (hDlg, $$DLG_CAP_RB_TIMELAPSE, $$DLG_CAP_RB_MOTION, $$DLG_CAP_RB_TIMELAPSE)
				CASE $$MONMODE_MODETECT
					CheckRadioButton (hDlg, $$DLG_CAP_RB_TIMELAPSE, $$DLG_CAP_RB_MOTION, $$DLG_CAP_RB_MOTION)
			END SELECT
			
			'frame interval
			stri$ = STRING$(AppState.frameInt)
			SetDlgItemTextA (hDlg, $$DLG_CAP_EDIT_FRAMEINT, &stri$)
			
			'max space
			stri$ = STRING$(AppState.spaceLimit)
			SetDlgItemTextA (hDlg, $$DLG_CAP_EDIT_MAXSPACE, &stri$)
			
			'save location
			SetDlgItemTextA (hDlg, $$DLG_CAP_EDIT_SAVLOC, &saveLocation)
			
			IF AppState.showRecIcon THEN
				SendDlgItemMessageA (hDlg, $$DLG_CAP_CHK_REDCIRCLE, $$BM_SETCHECK, $$BST_CHECKED, 0)
			ELSE
				SendDlgItemMessageA (hDlg, $$DLG_CAP_CHK_REDCIRCLE, $$BM_SETCHECK, $$BST_UNCHECKED, 0)
			END IF
			
			'now set the tooltips
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_RB_TIMELAPSE), hToolTips, "In this mode, SpyCam records continously")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_RB_MOTION), hToolTips, "In this mode, SpyCam waits for something to move before recording")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_EDIT_FRAMEINT), hToolTips, "The number of milliseconds to wait between taking each picture")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_EDIT_SAVLOC), hToolTips, "This is where SpyCam will save its data files")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_BT_CONFIGMOTION), hToolTips, "Click here to configure the motion detector")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_CHK_REDCIRCLE), hToolTips, "Select to display a red circle in the preview window while recording")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CAP_EDIT_MAXSPACE), hToolTips, "The maximum number of kilobytes that ThiefAware will use")
		CASE $$WM_COMMAND
			notifyCode = HIWORD(wParam)
			ID         = LOWORD(wParam)
			hwndCtl    = lParam
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE ID
						CASE $$IDOK
							'get the risky stuff out of the way first
							buffer$ = NULL$(4096)
							GetDlgItemTextA (hDlg, $$DLG_CAP_EDIT_SAVLOC, &buffer$, LEN(buffer$))
							buffer$ = CSTRING$(&buffer$)
							IF XstChangeDirectory (buffer$) THEN
								MessageBoxA (hDlg, &"Please specify an existing save location", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							
							fInt = GetDlgItemInt (hDlg, $$DLG_CAP_EDIT_FRAMEINT, 0, $$FALSE)
							IFZ fInt THEN
								MessageBoxA (hDlg, &"You must specify a non 0, positive frame interval", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							
							spaceLimit = GetDlgItemInt (hDlg, $$DLG_CAP_EDIT_MAXSPACE, 0, $$FALSE)
							IFZ spaceLimit THEN
								MessageBoxA (hDlg, &"Please specify a non 0 space limit", &"", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							
							saveLocation = buffer$
							
							capTime = (AppState.motionSettings.toCapCount*AppState.frameInt)\1000
							AppState.frameInt = fInt
							AppState.motionSettings.toCapCount = (capTime*1000)\AppState.frameInt
							
							AppState.spaceLimit = spaceLimit
							AppState.GSpaceLimit = GIANT(GIANT(AppState.spaceLimit) * GIANT(1024))
							
							'and now for the less risky stuff
							SELECT CASE TRUE
								CASE IsDlgButtonChecked (hDlg, $$DLG_CAP_RB_TIMELAPSE) = $$BST_CHECKED
									AppState.moniterMode = $$MONMODE_TIMELAPSE
								CASE IsDlgButtonChecked (hDlg, $$DLG_CAP_RB_MOTION) = $$BST_CHECKED
									AppState.moniterMode = $$MONMODE_MODETECT
							END SELECT
							
							IF SendDlgItemMessageA (hDlg, $$DLG_CAP_CHK_REDCIRCLE, $$BM_GETCHECK, 0, 0) = $$BST_CHECKED THEN
								AppState.showRecIcon = $$TRUE
							ELSE
								AppState.showRecIcon = $$FALSE
							END IF
							
							'success, we're done
							EndDialog (hDlg, $$TRUE)
						CASE $$IDCANCEL
							EndDialog (hDlg, $$FALSE)
						CASE $$DLG_CAP_BT_CONFIGMOTION
							
							'make sure the toCapCount is correct
							fInt = GetDlgItemInt (hDlg, $$DLG_CAP_EDIT_FRAMEINT, 0, $$FALSE)
							IF fInt THEN
								capTime = (AppState.motionSettings.toCapCount*AppState.frameInt)\1000
								AppState.frameInt = fInt
								AppState.motionSettings.toCapCount = (capTime*1000)\AppState.frameInt
							END IF
							
							IF DialogBoxParamA (hInst, $$DLG_CONFIGMOTION, hDlg, &ConfigMotionDlg(), 0) THEN
								'write reg values
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "sampleInt", AppState.motionSettings.sampleInt) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "blockSize", AppState.motionSettings.blockSize) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "tolerance", AppState.motionSettings.tolerance) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00\\Motion", "toCapCount", AppState.motionSettings.toCapCount) THEN QUIT(0)
							END IF
					END SELECT
			END SELECT
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' #############################
' #####  ConfigMotionDlg  #####
' #############################
' This dialog box is used to configure the motion detector
' Returns $$TRUE on OK, $$FALSE on CANCEL
FUNCTION ConfigMotionDlg (hDlg, msg, wParam, lParam)
	SHARED 		hInst
	SHARED	APPSTATE	AppState
	
	SELECT CASE msg
		CASE $$WM_INITDIALOG
			'initialise the controls
			hToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hDlg, 0, hInst, 0)
			SetWindowPos(hToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			SendMessageA(hToolTips, $$TTM_SETMAXTIPWIDTH, 0, 400)
			
			stri$ = STRING$(AppState.motionSettings.sampleInt)
			SetDlgItemTextA (hDlg, $$DLG_CONFIGMOTION_EDIT_SAMPLEINT, &stri$)
			
			stri$ = STRING$(myPower(AppState.motionSettings.blockSize))
			SetDlgItemTextA (hDlg, $$DLG_CONFIGMOTION_EDIT_BLOCKSIZE, &stri$)
			
			stri$ = STRING$((AppState.motionSettings.toCapCount*AppState.frameInt)\1000)
			SetDlgItemTextA (hDlg, $$DLG_CONFIGMOTION_EDIT_CAPTIME, &stri$)
			
			'set the range and ticks
			SendDlgItemMessageA (hDlg, $$DLG_CONFIGMOTION_TRKBR_TOLERANCE, $$TBM_SETRANGE, $$FALSE, 0x001F0000)
			SendDlgItemMessageA (hDlg, $$DLG_CONFIGMOTION_TRKBR_TOLERANCE, $$TBM_SETPOS, $$TRUE, AppState.motionSettings.tolerance>>3)
			
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIGMOTION_EDIT_SAMPLEINT), hToolTips, _
			"The number of milliseconds to wait between each frame that is checked for motion.\r\n\r\nA larger number will detect more motion, but could miss rapid changes")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIGMOTION_EDIT_BLOCKSIZE), hToolTips, _
			"The size of the blocks to compare.\r\n\r\nA smaller number means more motion is detected, but much more time and memmory is required.\r\n\r\nMust be a power of 2 and divide evenly into the frame size")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIGMOTION_EDIT_CAPTIME), hToolTips, _
			"The amount of time, in seconds, to record after detecting motion")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIGMOTION_TRKBR_TOLERANCE), hToolTips, _
			"A low tolerance will detect more motion, but is more prone to false alarms.\r\n\r\nA high tolerance has a higher chance of missing something important")
			
		CASE $$WM_COMMAND
			notifyCode = HIWORD(wParam)
			ID         = LOWORD(wParam)
			hwndCtl    = lParam
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE ID
						CASE $$IDOK
							sampleInt = GetDlgItemInt (hDlg, $$DLG_CONFIGMOTION_EDIT_SAMPLEINT, 0, $$FALSE)
							IFZ sampleInt THEN
								MessageBoxA (hDlg, &"Please enter a non 0 positive Sample Interval", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							blockSize = GetDlgItemInt (hDlg, $$DLG_CONFIGMOTION_EDIT_BLOCKSIZE, 0, $$FALSE)
							IF blockSize = 0 || myPower(INT(Log(DOUBLE(blockSize))/Log(2.0))) != blockSize THEN
								MessageBoxA (hDlg, &"Please enter a power of 2 for the Block Size", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							capTime = GetDlgItemInt (hDlg, $$DLG_CONFIGMOTION_EDIT_CAPTIME, 0, $$FALSE)
							IFZ capTime THEN
								MessageBoxA (hDlg, &"Please enter a non 0 positive capture time", &"note", $$MB_OK|$$MB_ICONINFORMATION)
								RETURN $$TRUE
							END IF
							
							AppState.motionSettings.sampleInt = sampleInt
							AppState.motionSettings.blockSize = INT(Log(DOUBLE(blockSize))/Log(2.0))
							AppState.motionSettings.tolerance = SendDlgItemMessageA (hDlg, $$DLG_CONFIGMOTION_TRKBR_TOLERANCE, $$TBM_GETPOS, 0, 0)<<3
							AppState.motionSettings.toCapCount = (capTime*1000)\AppState.frameInt
							EndDialog (hDlg, $$TRUE)
						CASE $$IDCANCEL
							EndDialog (hDlg, $$FALSE)
					END SELECT
			END SELECT
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' #######################
' #####  ConfigDlg  #####
' #######################
' This is the main configureation dialog box
' Returns $$TRUE
FUNCTION ConfigDlg (hDlg, msg, wParam, lParam)
	SHARED 		hInst
	SHARED	GUIINFO	GuiInfo
	SHARED	APPSTATE	AppState
	SHARED	STRING	saveLocation
	
	SELECT CASE msg
		CASE $$WM_INITDIALOG
			'initialise the controls
			hToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hDlg, 0, hInst, 0)
			SetWindowPos(hToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			SendMessageA(hToolTips, $$TTM_SETMAXTIPWIDTH, 0, 400)
			
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIG_TIMER), hToolTips, "Configure the timer")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIG_MONITERING), hToolTips, "Settings for recording and motion detection")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_CONFIG_DEVICE), hToolTips, "Configure hardware")
			
		CASE $$WM_COMMAND
			notifyCode = HIWORD(wParam)
			ID         = LOWORD(wParam)
			hwndCtl    = lParam
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE ID
						CASE $$IDOK,$$IDCANCEL
							EndDialog(hDlg, $$TRUE)
						CASE $$DLG_CONFIG_TIMER
							IF DialogBoxParamA (hInst, $$DLG_TIMER, hDlg, &ConfigTimerDlg(), 0) THEN
								'update the registry
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "timerStart", AppState.timerStart) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "timerEnd", AppState.timerEnd) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "useTimer", AppState.useTimer) THEN QUIT(0)
							END IF
						CASE $$DLG_CONFIG_MONITERING
							IF DialogBoxParamA (hInst, $$DLG_CAP, hDlg, &ConfigMoniterDlg(), 0) THEN
								'update the registry
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "monMode", AppState.moniterMode) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "frameInt", AppState.frameInt) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "showRecIcon", AppState.showRecIcon) THEN QUIT(0)
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "spaceLimit", AppState.spaceLimit) THEN QUIT(0)
								IFF WriteRegKeyString ("Software\\Callumscode\\ThiefAware\\1.00", "saveLocation", saveLocation) THEN QUIT(0)
							END IF
						CASE $$DLG_CONFIG_DEVICE
							devID = DialogBoxParamA (hInst, $$DLG_DEVSELECT, hDlg, &SelectDeviceDlg(), 0)
							'attempt to conenct it
							IF SendMessageA (GuiInfo.hCap, $$WM_CAP_DRIVER_CONNECT, devID, 0) THEN
								'success!
								AppState.devID = devID
								IFF WriteRegKey ("Software\\Callumscode\\ThiefAware\\1.00", "devID", AppState.devID) THEN QUIT(0)
								DialogBoxParamA (hInst, $$DLG_DEVCONFIG, hDlg, &ConfigDeviceDlg(), 0)
							ELSE
								MessageBoxA (hDlg, &"Cannot connect device", &"Device Error", $$MB_OK|$$MB_ICONSTOP)
								RETURN $$FALSE
							END IF
					END SELECT
			END SELECT
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' #############################
' #####  SelectDeviceDlg  #####
' #############################
' This dialog box selects a device
' Returns the id of the device on success or oxFFFFFFFF if there are no devices
FUNCTION SelectDeviceDlg (hDlg, msg, wParam, lParam)
	
	SELECT CASE msg
		CASE $$WM_INITDIALOG
			'fill in the list
			DIM DevIDs[9]
			k = 0
			FOR i = 0 TO 9
				name$ = SPACE$(255)+"\0"
				ver$ = SPACE$(255)+"\0"
				IF capGetDriverDescriptionA (i, &name$, LEN(name$), &ver$, LEN(ver$)) THEN
					stri$ = CSTRING$(&name$)+", "+CSTRING$(&ver$)
					SendDlgItemMessageA (hDlg, $$DLG_DEVSELECT_LB_LIST, $$LB_ADDSTRING, 0, &stri$)
					DevIDs[k] = i
					INC k
				END IF
			NEXT
			
			IF k = 0 THEN EndDialog (hDlg, 0xFFFFFFFF)
			
		CASE $$WM_COMMAND
			notifyCode = HIWORD(wParam)
			ID         = LOWORD(wParam)
			hwndCtl    = lParam
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE ID
						CASE $$IDOK, $$IDCANCEL
							i = SendDlgItemMessageA (hDlg, $$DLG_DEVSELECT_LB_LIST, $$LB_GETCURSEL, 0, 0)
							IF i = $$LB_ERR THEN
								MessageBoxA(hDlg, &"Select a device", &"note", $$MB_OK|$$MB_ICONINFORMATION)
							ELSE
								EndDialog (hDlg, i)
							END IF
					END SELECT
				CASE $$LBN_DBLCLK
					SELECT CASE ID
						CASE $$DLG_DEVSELECT_LB_LIST
							i = SendDlgItemMessageA (hDlg, $$DLG_DEVSELECT_LB_LIST, $$LB_GETCURSEL, 0, 0)
							IF i = $$LB_ERR THEN
								MessageBoxA(hDlg, &"Select a device", &"note", $$MB_OK|$$MB_ICONINFORMATION)
							ELSE
								EndDialog (hDlg, i)
							END IF
					END SELECT
			END SELECT
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' #############################
' #####  ConfigDeviceDlg  #####
' #############################
' This dialog box configures the selected device
' Returns $$TRUE or $$FALSE on error
FUNCTION ConfigDeviceDlg (hDlg, msg, wParam, lParam)
	SHARED 		hInst
	SHARED	GUIINFO	GuiInfo
	SHARED	APPSTATE	AppState
	
	CAPDRIVERCAPS CapDrvCaps

	SELECT CASE msg
		CASE $$WM_INITDIALOG
			'initialise the controls
			hToolTips = CreateWindowExA(0, &$$TOOLTIPS_CLASS, 0, $$WS_POPUP|$$TTS_NOPREFIX|$$TTS_ALWAYSTIP, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, $$CW_USEDEFAULT, hDlg, 0, hInst, 0)
			SetWindowPos(hToolTips, $$HWND_TOPMOST, 0, 0, 0, 0, $$SWP_NOMOVE|$$SWP_NOSIZE|$$SWP_NOACTIVATE)
			SendMessageA(hToolTips, $$TTM_SETMAXTIPWIDTH, 0, 400)
			
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_DEVCONFIG_SOURCE), hToolTips, "Select the video source")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_DEVCONFIG_FORMAT), hToolTips, "Set the video format\r\nNote: Please use rgb24 colour mode")
			SetToolTip (hDlg, GetDlgItem (hDlg, $$DLG_DEVCONFIG_DISPLAY), hToolTips, "Set display options (not very usefull)")
			
			'find out which buttons work for this device
			IFF SendMessageA (GuiInfo.hCap, $$WM_CAP_DRIVER_GET_CAPS, SIZE(CAPDRIVERCAPS), &CapDrvCaps) THEN
				EndDialog (hDlg, $$FALSE)
				RETURN $$FALSE
			END IF
			
			'now enable/disable as appropriate
			EnableWindow (GetDlgItem (hDlg, $$DLG_DEVCONFIG_SOURCE), CapDrvCaps.fHasDlgVideoSource)
			EnableWindow (GetDlgItem (hDlg, $$DLG_DEVCONFIG_FORMAT), CapDrvCaps.fHasDlgVideoFormat)
			EnableWindow (GetDlgItem (hDlg, $$DLG_DEVCONFIG_DISPLAY), CapDrvCaps.fHasDlgVideoDisplay)
			
		CASE $$WM_COMMAND
			notifyCode = HIWORD(wParam)
			ID         = LOWORD(wParam)
			hwndCtl    = lParam
			SELECT CASE notifyCode
				CASE $$BN_CLICKED
					SELECT CASE ID
						CASE $$IDOK,$$IDCANCEL
							SendMessageA (GuiInfo.hCap, $$WM_CAP_DRIVER_CONNECT, AppState.devID, 0)
							sizeCapWin ()
							EndDialog (hDlg, $$TRUE)
						CASE $$DLG_DEVCONFIG_SOURCE
							SendMessageA (GuiInfo.hCap, $$WM_CAP_DLG_VIDEOSOURCE, 0, 0)
						CASE $$DLG_DEVCONFIG_FORMAT
							SendMessageA (GuiInfo.hCap, $$WM_CAP_DLG_VIDEOFORMAT, 0, 0)
						CASE $$DLG_DEVCONFIG_DISPLAY
							SendMessageA (GuiInfo.hCap, $$WM_CAP_DLG_VIDEODISPLAY, 0, 0)
						CASE $$DLG_DEVCONFIG_COMPRESS
							SendMessageA (GuiInfo.hCap, $$WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0)
					END SELECT
			END SELECT
		CASE ELSE
			RETURN $$FALSE
	END SELECT
	RETURN $$TRUE
END FUNCTION
'
' ###########################
' #####  frameCallBack  #####
' ###########################
' This function is used in time lapse mode to record a frame
FUNCTION frameCallBack (hWnd, lpVHdr)
	SHARED	hInst
	SHARED	APPSTATE	AppState

	VIDEOHDR vhdr
	SYSTEMTIME sysTime
	
	pStruc = &vhdr
	XLONGAT(&&vhdr) = lpVHdr
	
	'ok, step 1, record the frame
	WriteFrame (vhdr.lpData, vhdr.dwBufferLength)
	
	'step 2, is it time to stop recording?
	GetLocalTime (&sysTime)
	nowTime = ((sysTime.wHour AND 0x00FF)<<16)|((sysTime.wMinute AND 0x00FF)<<8)|(sysTime.wSecond AND 0x00FF)
	
	IF AppState.useTimer && nowTime >= AppState.timerEnd && !AppState.noUseTimer THEN
		StopRecording ()
	ELSE
		IF AppState.showRecIcon THEN
			'draw a circle at 3,3
			FOR i = 9 TO 14
				SetBPixel (vhdr.lpData, i, 3, 255, 0, 0)
			NEXT
			FOR i = 7 TO 16
				SetBPixel (vhdr.lpData, i, 4, 255, 0, 0)
			NEXT
			FOR i = 6 TO 17
				SetBPixel (vhdr.lpData, i, 5, 255, 0, 0)
			NEXT
			FOR k = 6 TO 7
				FOR i = 5 TO 18
					SetBPixel (vhdr.lpData, i, k, 255, 0, 0)
				NEXT
			NEXT
			FOR k = 8 TO 13
				FOR i = 4 TO 19
					SetBPixel (vhdr.lpData, i, k, 255, 0, 0)
				NEXT
			NEXT
			FOR k = 14 TO 15
				FOR i = 5 TO 18
					SetBPixel (vhdr.lpData, i, k, 255, 0, 0)
				NEXT
			NEXT
			FOR i = 6 TO 17
				SetBPixel (vhdr.lpData, i, 16, 255, 0, 0)
			NEXT
			FOR i = 7 TO 16
				SetBPixel (vhdr.lpData, i, 17, 255, 0, 0)
			NEXT
			FOR i = 9 TO 14
				SetBPixel (vhdr.lpData, i, 18, 255, 0, 0)
			NEXT
		END IF
	END IF
	
	XLONGAT(&&vhdr) = pStruc
	
END FUNCTION
'
' #################################
' #####  frameMotionCallback  #####
' #################################
' This function is used in motion detection mode to detect motion
FUNCTION frameMotionCallback (hWnd, lpVHdr)
	SHARED	APPSTATE	AppState
	VIDEOHDR	vhdr
	SYSTEMTIME	sysTime
	
	pStruc = &vhdr
	XLONGAT(&&vhdr) = lpVHdr
	IF motion (vhdr.lpData) THEN
		StartRecording ()
	END IF
	
	'is it time to quit?
	GetLocalTime (&sysTime)
	nowTime = ((sysTime.wHour AND 0x00FF)<<16)|((sysTime.wMinute AND 0x00FF)<<8)|(sysTime.wSecond AND 0x00FF)
	
	IF AppState.useTimer && nowTime >= AppState.timerEnd THEN StopMotion ()
	XLONGAT(&&vhdr) = pStruc	
END FUNCTION
'
' ######################################
' #####  frameMotionFoundCallback  #####
' ######################################
' This function is used in motion detection mode to record footage once motion has been detected
FUNCTION frameMotionFoundCallback (hWnd, lpVHdr)
	SHARED	hInst
	SHARED	APPSTATE	AppState

	VIDEOHDR vhdr
	SYSTEMTIME sysTime
	
	pStruc = &vhdr
	XLONGAT(&&vhdr) = lpVHdr
	
	'ok, step 1, record the frame
	WriteFrame (vhdr.lpData, vhdr.dwBufferLength)
	DEC AppState.motionSettings.toCapture
	
	'do we need to detect motion yet
	SELECT CASE AppState.motionSettings.toCapture
		CASE 1
			motion (vhdr.lpData)
		CASE 0
			IFF motion (vhdr.lpData) THEN
				StopRecording()
			ELSE
				AppState.motionSettings.toCapture = AppState.motionSettings.toCapCount
			END IF
	END SELECT
	
	'step 2, is it time to stop recording?
	GetLocalTime (&sysTime)
	nowTime = ((sysTime.wHour AND 0x00FF)<<16)|((sysTime.wMinute AND 0x00FF)<<8)|(sysTime.wSecond AND 0x00FF)
	
	IF AppState.useTimer && nowTime >= AppState.timerEnd && !AppState.noUseTimer THEN
		StopRecording ()
	ELSE
		IF AppState.showRecIcon THEN
			'draw a circle at 3,3
			FOR i = 9 TO 14
				SetBPixel (vhdr.lpData, i, 3, 255, 0, 0)
			NEXT
			FOR i = 7 TO 16
				SetBPixel (vhdr.lpData, i, 4, 255, 0, 0)
			NEXT
			FOR i = 6 TO 17
				SetBPixel (vhdr.lpData, i, 5, 255, 0, 0)
			NEXT
			FOR k = 6 TO 7
				FOR i = 5 TO 18
					SetBPixel (vhdr.lpData, i, k, 255, 0, 0)
				NEXT
			NEXT
			FOR k = 8 TO 13
				FOR i = 4 TO 19
					SetBPixel (vhdr.lpData, i, k, 255, 0, 0)
				NEXT
			NEXT
			FOR k = 14 TO 15
				FOR i = 5 TO 18
					SetBPixel (vhdr.lpData, i, k, 255, 0, 0)
				NEXT
			NEXT
			FOR i = 6 TO 17
				SetBPixel (vhdr.lpData, i, 16, 255, 0, 0)
			NEXT
			FOR i = 7 TO 16
				SetBPixel (vhdr.lpData, i, 17, 255, 0, 0)
			NEXT
			FOR i = 9 TO 14
				SetBPixel (vhdr.lpData, i, 18, 255, 0, 0)
			NEXT
		END IF
	END IF
	
	XLONGAT(&&vhdr) = pStruc
	
END FUNCTION
'
' ###########################
' #####  fileIndex_add  #####
' ###########################
' Add a new file to the file index
' fileName = the FILENAME to add
' returns the id of the FILENAME in the structure
FUNCTION fileIndex_Add (FILENAME fileName)
	SHARED	FILENAME	fileIndex[]

	'look for a free slot
	slot = -1
	FOR i = 0 TO UBOUND(fileIndex[])
		IFF fileIndex[i].recordUsed THEN
			slot = i
			EXIT FOR
		END IF
	NEXT
	
	IF slot = -1 THEN 'we need more memmory
		slot = UBOUND(fileIndex[])+1
		REDIM fileIndex[((UBOUND(fileIndex[])+1)<<1)-1]
	END IF
	
	'ok, now write it in
	fileIndex[slot] = fileName
	fileIndex[slot].recordUsed = $$TRUE
	
	RETURN slot
END FUNCTION
'
' ###########################
' #####  fileIndex_Get  #####
' ###########################
' Retreives a FILENAME from the fileIndex
' id = the id of the FILENAME to get
' fileName = a variable to hold the FILENAME
' returns $$TRUE on success or $$FALSE on fail
FUNCTION fileIndex_Get (id, FILENAME fileName)
	SHARED	FILENAME	fileIndex[]
	
	'bounds checking
	IF id < 0 || id > UBOUND(fileIndex[]) THEN RETURN $$FALSE
	
	'is the record real?
	IFF fileIndex[id].recordUsed THEN RETURN $$FALSE
	
	'ok, give the caller its FILENAME
	fileName = fileIndex[id]
	RETURN $$TRUE
END FUNCTION
'
' ##############################
' #####  fileIndex_Update  #####
' ##############################
' Updates a FILENAME in the file index
' id = the id of the FILENAME to update
' fileName = the new version of the FILENAME
' returns $$TRUE on success or $$FALSE on fail
FUNCTION fileIndex_Update (id, FILENAME fileName)
	SHARED	FILENAME	fileIndex[]
	
	'bounds checking
	IF id < 0 || id > UBOUND(fileIndex[]) THEN RETURN $$FALSE
	
	'is the record real?
	IFF fileIndex[id].recordUsed THEN RETURN $$FALSE
	
	'ok, give the caller its FILENAME
	fileIndex[id] = fileName
	RETURN $$TRUE
END FUNCTION
'
' ##############################
' #####  fileIndex_Delete  #####
' ##############################
' Deletes a FILENAME from the fileIndex
' id = the id of the index to delete
' returns $$TRUE on success or $$FALSE on fail
FUNCTION fileIndex_Delete (id)
	SHARED	FILENAME	fileIndex[]
	
	'bounds checking
	IF id < 0 || id > UBOUND(fileIndex[]) THEN RETURN $$FALSE
	
	'is the record real?
	IFF fileIndex[id].recordUsed THEN RETURN $$FALSE
	
	fileIndex[id].recordUsed = $$FALSE
	RETURN $$TRUE
END FUNCTION

'
' #####################
' #####  myPower  #####
' #####################
' raises 2 to the power of a number
' n = the power that 2 will be raised to
' returns 2^n
FUNCTION myPower (n)
	ret = 1
	FOR i = 1 TO n
		ret = ret<<1
	NEXT
	RETURN ret
END FUNCTION
'
' ######################
' #####  SetPixel  #####
' ######################
' Sets a pixel
' addrBuffer = address of the buffer
' x and y = the x and y positions of the pixel
' r, g and b = the r, g and b components of the pixel
FUNCTION SetBPixel (addrBuffer, x, y, UBYTE r, UBYTE g, UBYTE b)
	SHARED	GUIINFO	GuiInfo
	
	offsetPixel = ((GuiInfo.capHeight-1-y)*GuiInfo.capWidth*3)+(x*3)
	
	UBYTEAT(addrBuffer, offsetPixel) = b
	UBYTEAT(addrBuffer, offsetPixel+1) = g
	UBYTEAT(addrBuffer, offsetPixel+2) = r
END FUNCTION
'
' ######################
' #####  getPixel  #####
' ######################
' Gets a pixel
' addrBuffer = the address of the buffer
' x and y = the x and y coordinates of the pixel
' returns the RGBQUAD of the pixel, .zero element contains garbage
FUNCTION RGBQUAD getPixel (addrBuffer, x, y)
	SHARED	GUIINFO	GuiInfo
	
	RGBQUAD rgbQuad
	
	offsetPixel = ((GuiInfo.capHeight-1-y)*GuiInfo.capWidth*3)+(x*3)
	
	ULONGAT(&rgbQuad) = ULONGAT(addrBuffer, offsetPixel)
	RETURN rgbQuad
END FUNCTION
'
' #########################
' #####  GreaterThan  #####
' #########################
' returns $$TRUE if ft1 > ft2, else returns $$FALSE
FUNCTION GreaterThan (FILETIME ft1, FILETIME ft2)
	IF ft1.dwHighDateTime > ft2.dwHighDateTime THEN
		RETURN $$TRUE
	ELSE
		IF ft1.dwHighDateTime = ft2.dwHighDateTime THEN
			IF ft1.dwLowDateTime > ft2.dwLowDateTime  THEN RETURN $$TRUE
		END IF
		RETURN $$FALSE
	END IF
END FUNCTION
'
' ######################
' #####  LessThan  #####
' ######################
' returns $$TRUE if ft1 < ft2, else returns $$FALSE
FUNCTION LessThan (FILETIME ft1, FILETIME ft2)
	IF ft1.dwHighDateTime < ft2.dwHighDateTime THEN
		RETURN $$TRUE
	ELSE
		IF ft1.dwHighDateTime = ft2.dwHighDateTime THEN
			IF ft1.dwLowDateTime < ft2.dwLowDateTime  THEN RETURN $$TRUE
		END IF
		RETURN $$FALSE
	END IF
END FUNCTION
'
' ##############################
' #####  ReadRegKeyString$  #####
' ##############################
' Reads in a string regestry key
' key$ and value$ = the key and value to read
' default$ = the default version of the string
' returns the value of the key on success or an empty string on critical failure
FUNCTION ReadRegKeyString$ (key$, value$, default$)
	Err = RegCreateKeyExA ($$HKEY_LOCAL_MACHINE, &key$, 0, 0, $$REG_OPTION_NON_VOLATILE, $$KEY_ALL_ACCESS, 0, &hKeyCC, &dwDisposition)
	IF Err != 0 THEN
		XstSystemErrorNumberToName (Err, @sysError$)
		MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN ""
	END IF
	
	IF dwDisposition = $$REG_CREATED_NEW_KEY THEN
		'Write the key
		GOSUB WriteDefault
	ELSE
		'Read the key
		i = 0
		valueName$ = SPACE$(255)+"\0"
		cbValueName = LEN(valueName$)
		DO UNTIL RegEnumValueA (hKeyCC, i, &valueName$, &cbValueName, 0, 0, 0, 0)
			IF MID$(valueName$, 1, cbValueName) = value$ THEN	'we've found the value
				'this call finds out how big the buffer needs to be
				RegQueryValueExA (hKeyCC, &value$, 0, 0, 0, &cbData)
				ret$ = SPACE$(cbData)+"\0"
				Err = RegQueryValueExA (hKeyCC, &value$, 0, 0, &ret$, &cbData)
				IF Err != 0 THEN
					XstSystemErrorNumberToName (Err, @sysError$)
					MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
					RegCloseKey (hKeyCC)
					RETURN ""
				END IF
				RegCloseKey (hKeyCC)
				RETURN CSTRING$(&ret$)
			END IF
			valueName$ = SPACE$(255)+"\0"
			cbValueName = LEN(valueName$)
			INC i
		LOOP
		
		'we didn't find the value, so make it
		GOSUB WriteDefault
	END IF
	
	RegCloseKey (hKeyCC)
	RETURN default$
	
	SUB WriteDefault
		Err = RegSetValueExA (hKeyCC, &value$, 0, $$REG_SZ, &default$, LEN(default$))
		IF Err != 0 THEN
			XstSystemErrorNumberToName (Err, @sysError$)
			MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
			RegCloseKey (hKeyCC)
			RETURN ""
		END IF
	END SUB
END FUNCTION
'
' ###############################
' #####  WriteRegKeyString  #####
' ###############################
' Writes a registry key
' key$ and value$ = the key and value
' var$ = the data to put in the value
' returns $$TRUE on success or $$FALSE on critical failure
FUNCTION WriteRegKeyString (Key$, Value$, Var$)
	
	Err = RegCreateKeyExA ($$HKEY_LOCAL_MACHINE, &Key$, 0, 0, $$REG_OPTION_NON_VOLATILE, $$KEY_ALL_ACCESS, 0, &hKeyCC, &dwDisposition)
	IF Err != 0 THEN
		XstSystemErrorNumberToName (Err, @sysError$)
		MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN $$FALSE
	END IF
	
	'Write the key
	Err = RegSetValueExA (hKeyCC, &Value$, 0, $$REG_SZ, &Var$, LEN(Var$))
	IF Err != 0 THEN
		XstSystemErrorNumberToName (Err, @sysError$)
		MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
		RegCloseKey (hKeyCC)
		RETURN $$FALSE
	END IF
	
	RegCloseKey (hKeyCC)
	
	RETURN $$TRUE
END FUNCTION
'
' ########################
' #####  ReadRegKey  #####
' ########################
' reads a DWORD registery key
' key$ and value$ = the key and value
' Default = the Default data for the value
' returns the value of the key
FUNCTION ReadRegKey (Key$, Value$, Default)
	XLONG Ret
	
	Err = RegCreateKeyExA ($$HKEY_LOCAL_MACHINE, &Key$, 0, 0, $$REG_OPTION_NON_VOLATILE, $$KEY_ALL_ACCESS, 0, &hKeyCC, &dwDisposition)
	IF Err != 0 THEN
		XstSystemErrorNumberToName (Err, @sysError$)
		MessageBoxA (0, &sysError$, &"Registry Error @1", $$MB_OK|$$MB_ICONSTOP)
		QUIT(0)
	END IF
	
	IF dwDisposition = $$REG_CREATED_NEW_KEY THEN
		'Write the key
		GOSUB WriteDefault
	ELSE
		'Read the key
		i = 0
		valueName$ = SPACE$(255)+"\0"
		cbValueName = LEN(valueName$)
		
		DO UNTIL RegEnumValueA (hKeyCC, i, &valueName$, &cbValueName, 0, 0, 0, 0)
			IF MID$(valueName$, 1, cbValueName) = Value$ THEN	'we've found the value
				'so read it
				cbData = 4
				Err = RegQueryValueExA (hKeyCC, &Value$, 0, 0, &Ret, &cbData)
				IF Err != 0 THEN
					XstSystemErrorNumberToName (Err, @sysError$)
					MessageBoxA (0, &sysError$, &"Registry Error @1", $$MB_OK|$$MB_ICONSTOP)
					QUIT(0)
				END IF
				RegCloseKey (hKeyCC)
				RETURN Ret
			END IF
			valueName$ = SPACE$(255)+"\0"
			cbValueName = LEN(valueName$)
			INC i
		LOOP

		'we didn't find the value, so make it
		GOSUB WriteDefault
	END IF
	
	RegCloseKey (hKeyCC)
	RETURN Default

	
	SUB WriteDefault
		Err = RegSetValueExA (hKeyCC, &Value$, 0, $$REG_DWORD, &Default, 4)
		IF Err != 0 THEN
			XstSystemErrorNumberToName (Err, @sysError$)
			MessageBoxA (0, &sysError$, &"Registry Error @2", $$MB_OK|$$MB_ICONSTOP)
			QUIT(0)
		END IF
	END SUB
END FUNCTION
'
' #########################
' #####  WriteRegKey  #####
' #########################
' Writes a DWORD registry key
' key$ and value$ = the key and value
' Var = the data to put in the value
' returns $$TRUE on success and $$FALSE on critical failure
FUNCTION WriteRegKey (Key$, Value$, Var)
	
	Err = RegCreateKeyExA ($$HKEY_LOCAL_MACHINE, &Key$, 0, 0, $$REG_OPTION_NON_VOLATILE, $$KEY_ALL_ACCESS, 0, &hKeyCC, &dwDisposition)
	IF Err != 0 THEN
		XstSystemErrorNumberToName (Err, @sysError$)
		MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN $$FALSE
	END IF
	
	'Write the key
	Err = RegSetValueExA (hKeyCC, &Value$, 0, $$REG_DWORD, &Var, 4)
	IF Err != 0 THEN
		XstSystemErrorNumberToName (Err, @sysError$)
		MessageBoxA (0, &sysError$, &"Registry Error", $$MB_OK|$$MB_ICONSTOP)
		RETURN $$FALSE
	END IF
	
	RegCloseKey (hKeyCC)
	
	RETURN $$TRUE
END FUNCTION
'
' ############################
' #####  SetToolTipText  #####
' ############################
' sets the text for a tooltip
FUNCTION  SetToolTipText (addrTOOLTIPTEXT, text$)

	TOOLTIPTEXT ttt
	strucAddr = &ttt
	XLONGAT(&&ttt) = addrTOOLTIPTEXT
	ttt.lpszText = &text$																' assign address of tooltip text to ttt.lpszText
	XLONGAT(&&ttt) = strucAddr

END FUNCTION

END PROGRAM

